import os
import config,utils,thread

def createcluster(awsid,awssecretkey,awskeypair,instances,instancetype,bootstrap):
	clusterid = utils.GetRandomString()
	if bootstrap != "":
		bootstrap = "-i="+bootstrap
	cmd = "python %s --create -a=%s -p=%s -kp=%s -n=%s -t=%s %s > /tmp/%s.out 2> /tmp/%s.err" % (config.emrcontroller,awsid,awssecretkey,awskeypair,instances,instancetype,bootstrap,clusterid,clusterid)
#	raise Exception (cmd)
	p = utils.run(cmd)
	thread.start_new_thread(utils.continuejob,(p,))
	return clusterid+","+str(p.pid)

def pollstatus(clusterid):
	pid = clusterid.split(",")[1]
	status = utils.getprocesstatus(pid)
	return status
	
def getdomaind(clusterid):
	clusterid = clusterid.split(",")[0]
	stdout = open("/tmp/"+clusterid+".out").read().strip().split("\n")
	domain = None
	for line in stdout:
		if line.startswith("domain"):
			domain = line.split(":")[1].strip()
	if domain is None:
		return "E"
	else:
		return domain

def getstderr(clusterid):
	clusterid = clusterid.split(",")[0]
	stderr = open("/tmp/"+clusterid+".err").read().strip()
	stdout = open("/tmp/"+clusterid+".out").read().strip()
	return stdout + "\nError: \n" + stderr 
