#! /usr/bin/env python
#import HPCLoudEMR
import sys,subprocess
def run(excuter,Wait=True):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	
	if Wait:
		p.wait()
		st=p.stderr.read()
		if len(st)>0:
			f = open("/tmp/ToolService.err",'w')
			f.write(st)
			f.flush()
			f.close()
			return "Childerr:" + st
		
		else:
			return str(p.stdout.read()).strip()
	else:
		return p

domain = sys.argv[1]
id=sys.argv[2]
cmd="./blastn -query /home/hadoop/query.1000.formatted -db est_human/est_human -out /home/hadoop/blast/out.blast"
inputList=["s3://eg.nubios.us/emr/query.1000.formatted"]
outputFiles=["/home/hadoop/blast/out.blast"]
outputDir="/home/hadoop/output/" +id
reduc="NONE"
cacheArchives=["hdfs:///home/hadoop/dbs/est_human.tar.gz#est_human"]
cacheFiles=["s3://eg.nubios.us/emr/blastn.64#blastn"]
conf=["mapred.reduce.tasks=1","mapred.map.tasks=1"]

c="./HPC-cloud-EMR --submit --mode=hadoop -d=%s -id=%s --command='%s' --input-files='%s' --output-files='%s' --output-dir='%s' --reducer=%s -ca=%s -cf=%s --conf='%s'" % (domain,id,cmd,str(inputList)[1:-1],outputFiles,outputDir,reduc,str(cacheArchives)[1:-1],str(cacheFiles)[1:-1],str(conf)[1:-1])
print c
#print run(c)
