import sys, os
import utils
import config
import subprocess
sys.path.append(os.path.join(config.emrscripts,"Client"))
import CommandClient
import ClientJob


def run(excuter,Wait=True):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	
	if Wait:
		p.wait()
		st=p.stderr.read()
		if len(st)>0:
			return "Childerr:" + st
		
		else:
			return str(p.stdout.read()).strip()
	else:
		return p

def submitjob(domain,command,mode,owner):
	id = utils.GetRandomString()
#	return command
	cmd=config.emrscripts + "/HPC-cloud-EMR --submit -d=%s -m=%s --command='%s' --owner=%s -id=%s"%(domain,mode,command,owner,id)
#	return cmd
	x= run(cmd,True)
	if "Done" in x:
		return "Done"
	elif "Job ID:" in x:
		return x.split(":")[1]
	else:
		return x.split('\n')[-1]
	
def pollstatus(domain,jobid):
	return ClientJob.checkStatus(domain,jobid,"emrinterface")
	
