#! /usr/bin/python
import config
import os, MySQLdb,subprocess,random,simplejson
import Utils,config,ConfigParser
from boto.s3.connection import S3Connection
from boto.s3.connection import Location
from mod_python import util,Cookie

def index():
	return "Hello"

def redirect(url,req):
	  util.redirect(req,  url)
def fbuffer(f, chunk_size=10000):
   while True:
      chunk = f.read(chunk_size)
      if not chunk: break
      yield chunk
      

def MyClustersAsList(req):
	UUID=Utils.getUserUid(req)
	st="select * from EC2Instances where UUID='"+UUID+"' and EC2Instances.Terminated=0"
	#return st
	rows=Utils._select(st)
	res="<div class='form-row toolParam' type='select' id='cluster'><label>Select cluster</label><select>"
	for row in rows:
		res+="<option value='" + row["DNS"] + "'>" + row["Name"] + "</option>"
	res +="</select></div><div class='form-row toolParam' type='boolean' truevalue='1' falsevalue='0' id='tof'><label>Terminate on Finish</label><input type='checkbox'></div><div><a href='#' onclick=\"NavigateTo('../../myCloud/settings.html')\">Start New Cluster</a></div>"
	
	return res

def getUserAWSConf(req):
	UUID=Utils.getUserUid(req)
	path=config.WebBaseStorageFolder+UUID+"/aws/aws.conf"
	print "File @: " + path
	conf = ConfigParser.RawConfigParser()
	conf.read(path)
	dict={}
	dict["pkeyfile"]=conf.get('aws','pkey')
	dict["certfile"]=conf.get('aws','cert')
	dict["accessKey"]=conf.get('aws','accessKey')
	dict["secretKey"]=conf.get('aws','secretKey')
	return dict

	
def createBucket(req):
	AccessKey=req.form["accessKey"].value
	SecretKey=req.form["secretKey"].value
	Name=req.form["Name"].value
	loc=req.form["Loc"].value
	conn = S3Connection(AccessKey,SecretKey)
	try:
		if (loc=="EU"): 
			bucket = conn.create_bucket(Name,location=Location.EU)
		else: 
			bucket = conn.create_bucket(Name)
		return getBuckets(req,Name)
	except:
		return "Choose another name"
def getStatus(req):
	st=""
	UUID=Utils.getUserUid(req)
	logPath=config.WebBaseStorageFolder+UUID+"/tmp/cluster.log"
	f=open(logPath,'r')
	for line in f.readlines():
		st=line+st
	return "<html><pre>"+st+"</pre></html>"
	#return f.readlines()
def getKeys(req,region):
	d=getUserAWSConf(req)
	comm= config.cloudRunner + '/startEC2 '  + d["pkeyfile"] + " " + d["certfile"] + " "  + region+ " --keypairs"
#	return comm
	st = runAndWait(comm)
	#return st
	keys=st.split("KEYPAIR ")
	res="<select id='sshKey' name='sshKey'>"
	
	for key in keys[1:]:
		
		name=key.split(" ")[0]
		res+="<option value='" + name + "'>" + name + "</option>"  
	return res+"</select>"
	
def getGroups(req,region):
	d=getUserAWSConf(req)
	comm=config.cloudRunner + '/startEC2 '  + d["pkeyfile"] + " " + d["certfile"] + " "  + region+ " --groups"
	#return comm
	st = runAndWait(comm)
	#return st
	res="<select id='secgroup' name='secGroup'>"
	for line in st.split("\n"):
		if "GROUP" in line:
			name=line.split("\t")[-2]
			res +=  "<option value='" +name + "'>" + name+"</option>"
		#return line
		#	if ("GROUP" in line):
		#res += line.split("  ")
					 
	#keys=st.split("KEYPAIR ")
	return  res + "</select>"
	"""res="<select id='sshKey' name='sshKey'>"
	
	#for key in keys[1:]:
		
		name=key.split(" ")[0]
		res+="<option value='" + name + "'>" + name + "</option>"  
	return res+"</select>"
	"""
	
#Get User buckets
def getBuckets(req,selected=None):
	#return req.form.keys
	d=getUserAWSConf(req)
	AccessKey=d["accessKey"]
	SecretKey=d["secretKey"]
	#return AccessKey+":"+SecretKey
	conn = S3Connection(AccessKey,SecretKey)
	buckets = str(conn.get_all_buckets())
	blist=[]
	b= buckets.split(',')
	html="<td>S3 Bucket:</td><td><select name='s3' id='BucketName'>"
	for bucket in b:
			st=""
			if bucket != b[-1]:	st = bucket.split(':')[1][1:-1]
			else: st = bucket.split(':')[1][1:-2]
			if (st!=selected):
				html+="<option value='" + st+"'>" + st + "</option>"
			else:
				html+="<option value='" + st+"' selected='selected'>" + st + "</option>"
	
	html+="</select>&nbsp;&nbsp;<a id='newBucket' onclick='ShowNewBucketArea()' href='#'>Create New Bucket</a></td>"
	return html
	#return simplejson.dumps(blist)
	
	
# Run the prepared command

def runAndWait(executer):
	p =run (executer)
	p.wait()
	st=p.stderr.read()
	if len(st)>0:
		f = open("/tmp/ToolService.err",'w')
		f.write(st)
		f.flush()
		f.close()
		return "Childerr:" + st
		
	else:
		return str(p.stdout.read()).strip()
	
def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	return p
#	p.wait()
#	st=p.stderr.read()
#	if len(st)>0:
#		f = open("/tmp/ToolService.err",'w')
#		f.write(st)
#		f.flush()
#		f.close()
#		return "Childerr:" + st
		
#	else:
#		return str(p.stdout.read()).strip()

def _insert(st):
	
	db = connectToDB()
	cursor=db.cursor()
	cursor.execute(st)
	db.commit()
	cursor.close ()
	db.close()
def save(req):
	insertStatement=""
	UUID=Utils.getUserUid(req)
	path=config.WebBaseStorageFolder+UUID+"/aws/"
	if ("enable" in req.form.keys()):
		pkey=req.form["pkey"]
		cert=req.form["cert"]
	#	region="EU1" #req.form["region"]
	#	secGroup=req.form["secGroup"]
	#	sshKey=req.form["sshKey"]
		accessKey=req.form["accessKey"]
		secretKey=req.form["secretKey"]
		pkeyfile=""
		certfile=""
		conffile="[aws]\n"
	
	
#	path="/root/certs/"
		try:
			os.makedirs(path)
		except Exception:
			pass
		i=0
		while i<2:
			i+=1
			fpath=""
			fileitem=""
			if (i==1):
				fileitem = pkey
				#fname = os.path.basename(fileitem.filename)
				fpath=path +"pk.pem"
				conffile+="pkey: " + fpath + "\n"	
				pkeyfile=fpath
			#	if (os.path.exists(pkeyfile)):continue
			else:
				fileitem=cert
				#fname = os.path.basename(fileitem.filename)
				fpath=path +"cert.pem"
				conffile += "cert: " + fpath + "\n"
				certfile=fpath
			#	if (os.path.exists(certfile)):continue
			#return fpath
			f = open(fpath, 'wb', 10000)
		# Read the file in chunks
			for chunk in fbuffer(fileitem.file):
				f.write(chunk)
			f.close()
		conffile += "accessKey: " + accessKey + "\n"
		conffile += "secretKey: " + secretKey + "\n"
	#	conffile += "sshKey: " + sshKey + "\n"
	#	conffile += "group: " + secGroup + "\n"
	
		f = open ( path+'aws.conf','w')
		f.write(conffile)
		f.flush()
		f.close()
		
		insertStatement = "update users set EnableAWS=1 where Rand='" + UUID + "'"
	else:
		insertStatement ="update users set EnableAWS=0 where Rand='" + UUID + "'"
#	return st
	_insert(insertStatement)
#	return "saved"
	util.redirect(req,"../../setup.html")
	
		
	
def start(req):
	UUID=Utils.getUserUid(req)
	try:
		os.makedirs(config.WebBaseStorageFolder+UUID+"/tmp/")
	except:
		pass
	logPath=config.WebBaseStorageFolder+UUID+"/tmp/cluster.log"
	run ('echo "" > ' + logPath)
	
	#return req.form.keys
	#pkey=req.form["pkey"]
	#return pkey
	#cert=req.form["cert"]
	region= req.form["region"]
	cores=req.form["cores"]
	mType=req.form["mType"]
	s3=req.form["s3"]
	sshKey=req.form["sshKey"]
	secGroup=req.form["secGroup"]
	ClusterName=req.form["CName"]
	sshKey=req.form["sshKey"] #"MyEUKey.pem"
	
	#accessKey=req.form["accessKey"]
	#secretKey=req.form["secretKey"]
	#pkeyfile=""
	#certfile=""
		
	UUID=Utils.getUserUid(req)
	path=config.WebBaseStorageFolder+UUID+"/aws/"
	awsfile=path+'aws.conf'
#	path="/root/certs/"
	"""try:
		os.makedirs(path)
	except Exception:
		pass
	i=0
	while i<3:
		i+=1
		fpath=""
		fileitem=""
		if (i==1):
			fileitem = pkey
			#fname = os.path.basename(fileitem.filename)
			fpath=path +"pk.pem"
			pkeyfile=fpath
			if (os.path.exists(pkeyfile)):continue
		else:
			fileitem=cert
			#fname = os.path.basename(fileitem.filename)
			fpath=path +"cert.pem"
			certfile=fpath
			if (os.path.exists(certfile)):continue
		#return fpath
		f = open(fpath, 'wb', 10000)
		# Read the file in chunks
		for chunk in fbuffer(fileitem.file):
			f.write(chunk)
		f.close()
	f = open ( path+'.passwd-s3fs','w')
	f.write(accessKey+":"+secretKey)
	f.flush()
	f.close()
	"""
	command = config.cloudRunner + "/CommandClient.py --create " + region + " '" + mType + "-" + cores + "' "   + awsfile +" " +sshKey + " " + secGroup  + " " + s3 + " " + ClusterName + " &" 
#	return command
	
	
	text=run(command)
	#return text
		
	#IP=run ("/var/www/cloud/py/startEC2 " + region)
#	 return  IP
	#if ("Childerr: " in  text):
	#	return "Err: " + text
	#else:
	#	import time
	#	time.sleep(20)
#	redirect("../../MyClusters.html",req)  
#	return "<a href='http://" + URL + "/nubios' target='_blank'>Machine is ready you can start here</a><br/><a href='py/aws/terminate?ip=" + URL + "&region=" + region + "'>Click here</a> to terminate the machine"  
	return "Creating Cluster......"
def connectToDB():
	return MySQLdb.connect(host=config.usersDBhost, port=int(config.usersDBport),user=config.usersDBun, passwd=config.usersDBun,db=config.usersDB)

#def terminate(ip,region):
#	res=run ("/var/www/cloud/py/terminateEC2 " + region + " " + ip)
#	return res
#	if ('Done' in res):
#		return "Instance Teriminate. Thank You"

def terminateCluster(domain):
	st = "select ID,UUID,Region from EC2Instances where DNS='"+domain+"'"
	rows =Utils._select(st)
	for row in rows:
		id = rows["ID"]		
		UUID = rows["UUID"]
		region = rows["Region"]
		break
	awsconf=config.WebBaseStorageFolder+UUID+"/aws/aws.conf"
	command = config.cloudRunner + "/CommandClient.py --terminate " + awsconf + " " + region + " "   + id  + " " + domain
	res = runAndWait(command)
	Utils._insert("delete from EC2Instances where DNS='" + domain + "'")
	return "Done"


def terminate(req,region,id,domain):
	UUID=Utils.getUserUid(req)
	awsconf=config.WebBaseStorageFolder+UUID+"/aws/aws.conf"
	#pkey=path+"pkey.pem"
	#cert=path+"cert.pem"
	command = config.cloudRunner + "/CommandClient.py --terminate " + awsconf + " " + region + " "   + id  + " " + domain
	#return command
	
	res = runAndWait(command)
	
	#return res
	Utils._insert("delete from EC2Instances where DNS='" + domain + "'")
	return "Done" 

def MyClusters(req):
	UUID=Utils.getUserUid(req)
	st="select * from EC2Instances where UUID='"+UUID+"' and EC2Instances.Terminated=0"
	#return st
	rows=Utils._select(st)
	disRows=[]
	for row in rows:
		r={"id": row["ID"]}
		cell=[row["instanceID"],row["Name"],"<span style='text-decoration: underline'><a href='http://"+row["DNS"]+"/tavaxy'>"+ row["DNS"]+"</a></span>",row["Region"],row["Cores"], row["StartOn"],"<span style='text-decoration: underline'><a href='#' onclick='terminate(event,\""+row["Region"] + "\",\"" + row["instanceID"] +"\",\"" + row["DNS"]+"\")'>Terminate</a></span>"]
		r["cell"]=cell
		disRows.append(r)
	d={"page":"1","total":1,"records": str(len(rows)),"rows":disRows}
	return simplejson.dumps(d)

def RetreiveBuckets(req,accessKey,secretKey):
	#return req.form.keys
	#return AccessKey+":"+SecretKey
	conn = S3Connection(accessKey,secretKey)
	buckets = str(conn.get_all_buckets())
	blist=[]
	b= buckets.split(',')
	html=""
	for bucket in b:
		st=""
		if bucket != b[-1]:	st = bucket.split(':')[1][1:-1]
		else: st = bucket.split(':')[1][1:-2]
		html+="<option value='" + st+"'>" + st + "</option>"
	
	html+="</select>"
	return html

