#!/usr/bin/python
import socket
import config
import sys
import os
import simplejson
mode = sys.argv[1]

def GetElements(input,elements):
	for i in range(0,len(input)):
		if isinstance(input[i],list):
			GetElements(input[i],elements)
		else:
			elements.append(input[i])
	return elements
	
def GetProperList(input):
	if isinstance(input,list):
		if len(input) == 1:
			return GetProperList(input[0])
	return input

def SendFile(file):
	dirName = os.path.dirname(file)
	cmd = "ssh " + host + " 2>&1; mkdir -p " + dirName + " 2>&1;"
	os.system(cmd)
	cmd = "scp " + file + " " + host + ":" + file + " 2>&1;"
	os.system(cmd)

def RemoveFile(file):
	cmd = "ssh " + host + " 2>&1; rm " + file + " 2>&1;"
	os.system(cmd)

def GetFile(file):
	try:
		dirName = os.path.dirname(file)
		if not os.path.isdir(dirName):
			os.makedirs(dirName)
	except:
		pass
	cmd = "scp " + host + ":" + file + " " + file + " 2>&1;"
	os.system(cmd)

address = socket.gethostname()

if config.user == "":
	host = config.mainNode
else:
	host = config.user + "@" + config.mainNode

for i in range(2,len(sys.argv)):
	try:
		value = simplejson.loads(open(sys.argv[i]).read().strip())
		value = GetProperList(value)
		if isinstance(value,list):
			files = []
			GetElements(value,files)
	except:
		pass
if mode == "pre":
	if address != config.mainNode:
		for i in range(2,len(sys.argv)):
			GetFile(sys.argv[i])
			try:
				value = simplejson.loads(open(sys.argv[i]).read().strip())
				value = GetProperList(value)
				if isinstance(value,list):
					files = []
					GetElements(value,files)
					for file in files:
						GetFile(file)
			except:
				pass
elif mode == "post":
	if address != config.mainNode:
		for i in range(2,len(sys.argv)):
			SendFile(sys.argv[i])
			try:
				value = simplejson.loads(open(sys.argv[i]).read().strip())
				value = GetProperList(value)
				if isinstance(value,list):
					files = []
					GetElements(value,files)
					for file in files:
						SendFile(file)
				else:
					SendFile(value)
			except:
				pass
elif mode == "remove":
	if address != config.mainNode:
		for i in range(2,len(sys.argv)):
			RemoveFile(sys.argv[i])
