#! /usr/bin/python

import sys,subprocess,splitter,os,simplejson
mainPath=os.path.dirname(os.path.abspath( __file__ ))[:-3]+"/files/" + sys.argv[1]+'/'
s3dict={}
if not os.path.exists(mainPath):
	os.makedirs(mainPath)
os.chdir(mainPath)
outFile=[]
def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	if len(st)>0:
		f = open("/tmp/ToolService.err",'w')
		f.write(st)
		f.flush()
		f.close()
		return "Childerr: "+st
		
	else:
		return p.stdout.read()

def getS3Path(path):
	parts = path.split('/')
#	print parts
	return [parts[2], '/'.join(parts[3:])]

def runSplitter(file):
	s=file.split('##')
	blockSize=s[2]
	seprator=s[1]
	if s[1]=="": 
		seprator="none"
		blockSize=0
	p=getS3Path(s[0])
	print p
	fname=mainPath+p[1].split('/')[-1]
	splitter.fileSplit(fname,seprator,blockSize,fname+".sep")
	return fname+".sep"
orderID=sys.argv[1]
args=sys.argv[2].split(" ")
command=""
inputLst=[]
stageInLst=[]
stageOutLst=[]
outputLst=[]
splitted=False

for arg in args:
	#part=""	
	added=False
	if 's3://' in arg and '__o__' not in arg:
		print 'Download:', arg
		x=arg.split("##")[0]
		print x
		p=getS3Path(x)
		filename=p[1].split('/')[-1]
		print filename
		if arg!=args[0]:
			inputLst.append(filename)
		cmd="cd %s;wget -nd -c -S -T 10 -t 5 http://%s.s3.amazonaws.com/%s"%(mainPath,p[0],p[1])
		#print cmd
		t=run (cmd)
		if "ERROR 40" in t:
			open(mainPath+'error.txt','w').write("Can't Download '" +p[1]+ "': either file doesn't exist or not publicly avaliable")
			exit(-1) 
		run("chmod 777 " + mainPath+filename )
		if (not "##" in arg):
			command+=mainPath+filename+" "
			stageInLst.append(mainPath+filename)
			added=True
		print "New Command:",command
	if '##' in arg:
			s=arg.split('##')
			#if s[1]!="" and s[2]!="":
			print "Running splitter..."
			runSplitter(arg)
			command += "p__sep__"+ filename + " " + mainPath+filename + ".sep"
			stageInLst.append(mainPath+filename+".sep")
			added=True
			splitted=True
#		else:
#				command+=s[0]

	elif "__o__" in arg and splitted:

		
				o=arg.split("_o__")[1].split("__")
				print "o=",o
				if "s3://" in o[1]:
					t=o[1].split('/')[-1]
					print "t=" , t
					s3dict[t]=o[1]
					o[1]=t
					
				if not os.path.exists(os.path.dirname(mainPath+o[1])):
					os.makedirs(os.path.dirname(mainPath+o[1]))
				command+="p__sep__" + o[0] + " " + mainPath+o[1]
				stageOutLst.append(mainPath+o[1])
				added=True
				outFile.append(mainPath+o[1])
				print arg
				outputLst.append(o[0])
	elif not added:
		command+=arg
	if arg!=args[-1]:
		command += ' '
		
#output1 local 0 0 input1  __command__ /var/www/HPCloud-Demo/py/seqret  -sequence p__sep__input1 /var/www/HPCloud-Demo/py/files/input1.sep -out p__sep__output1 result.fasta __command__
print "Command to execute: " , command
stageInCommand="" #"mkdir "+mainPath+sys.argv[1]+";"
#for file in stageInLst:
#	c='scp HPC-cloud-0:' + file + " " + file +";"
#	stageInCommand+=c
run('chmod 777 -R ' + mainPath)
cmd= '/root/EHPC/CommandClient.py --run 127.0.0.1 ' + sys.argv[1] + ' ubuntu "' + stageInCommand+'python /var/www/runner/lstPattern/listWrapper_cloud_param.py toolID cross ' + ','.join(outputLst) + " local 0 0 " + ','.join(inputLst) + " __command__ "+command + " __command__ > /tmp/out.std 2> /tmp/err.std\""
print cmd
#exit(0)
run(cmd)
if len(s3dict)>=0:
	for key in s3dict:
		if splitted:
			info=open(mainPath+key,'r').read()
			files=simplejson.loads(info)
			print files
			c='/root/HPCloud/inputGrabber.py S3 output ' + ','.join(files) +' ' +s3dict[key]+'/'
			run(c)
		else:
			c='/root/HPCloud/inputGrabber.py S3 output ' + mainPath+key  +' ' +s3dict[key]
			run (c)
html="""<html><body>
	<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>HPC-cloud -  Result</title>
	
	<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.7.1/jquery.min.js"></script>
	<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jqueryui/1.8.18/jquery-ui.min.js"></script>
	<link rel="stylesheet" href="http://ajax.googleapis.com/ajax/libs/jqueryui/1/themes/cupertino/jquery-ui.css" type="text/css" />	
	<link rel="stylesheet" type="text/css" href="/cluster/theme/stylesheet.css" />
	<link rel="stylesheet" type="text/css" href="resources/css/style.css" />
	
	<script type="text/javascript" src="/cluster/js/theme.js"></script>
	</head>
<body>
	   <div align="center" class="container">
					   
           <div id="topArea" class="ui-widget-content">
					   </div>
            <table width="100%" class="ui-accordion-content ui-helper-reset ui-widget-content ui-corner-bottom ui-accordion-content-active">
                <tr>
                    <td  class="containerTable"  >
                                    <div id="leftMenuArea" width="0px"></div>
                                    </td>
                    <td align="center" width="600px" style="vertical-align:top">
                    <h1>Output</h1>
                    <div align='left'>
                    <h2>Output Files:</h2>
                    <ol>
                    """

for file in outFile:
	print "reading" +file
	f=simplejson.loads(open(file).read())
	for res in f:
		print "adding link for " + res
		html+="<li><a href='" + res.split("/")[-1]+"'>"+res.split("/")[-1]+"</a></li>"
html+="""</ol></div></td>
					
					 </tr></table>
				<div id="footerArea" class="ui-widget-content">
               
            </div>
          </div>
</body></html>"""
print "Writing results file on: ", '/'.join(mainPath.split('/')[:-2])+'/results/' + orderID +'.html'
file=open( mainPath+ 'result.html','w')
file.write(html)
file.flush()
file.close()
#print "Writing Finished file on: ", '/'.join(mainPath.split('/')[:-2])+/ orderID + '/Finished.txt'
f=open(mainPath+'Finished.txt','w')
f.write("")
f.close()  


