#!/usr/bin/python
from Crypto.PublicKey import RSA
from Crypto import Random
import socket,threading,subprocess,os,base64,xml.dom.minidom
import PBS,Response,Request,ServerJob as Job  
JOBS={}
EOM="\n\n###"
def startServer():
    port=5000
    s = socket.socket(socket.AF_INET,socket.SOCK_STREAM)
    s.setsockopt(socket.SOL_SOCKET,socket.SO_REUSEADDR,1)
    s.bind(('',port))
    s.listen(5)
    print "Server started at " + str(port)
    return s
def importKey():
	
	file=open("/home/hadoop/CommandServer/client.pub",'r')
	st = file.read()
#	print "string: ", st
	key = RSA.importKey(st)
	return key
def validReq(req):
	key =importKey()
	decrypted=key.decrypt(base64.decodestring(req["sec"]))
	print "decryptedText= ", decrypted
	if (req["JobID"] + req["Owner"]==decrypted):
		return True
	else: return False
def HandleClient(clientsock):
	name = threading.currentThread().getName()
	print name, ' Started.............'
	global EOM
	chunks=[]
#	DownlodFLV=False
	while 1:
		buf = clientsock.recv(2048)
		chunks.append(str(buf))
		if (EOM in chunks[-1]):
			#TODO: Verify Message Sender
			msg= "".join(chunks)[:-5]
	#		print msg
			if (msg=="TEST: HELLO"):
				return
			req =Request.parseRequest(msg)
			if (not validReq(req)):
				Response.sendData(clientsock,"Invalid Request")
				print "invalid request"
				clientsock.close()
				return 
			if (req["requestType"]=="SUBMIT"):
				job=Request.parseJob(msg)
				global	JOBS
				if (req["Owner"]=="system"):
					print job["command"]
					PBS.run(job["command"],req["JobID"],job["variables"])
					Response.sendData(clientsock,"Done")
				elif (req["Owner"]=="hadoop"):
					print job["command"]
					id=PBS.runHadoop(job["command"],req["JobID"])
					if 'Error' in id:
						Response.sendData(clientsock,id)
					else:
						Response.sendData(clientsock,"recieved:" + id)

				else:
					#id = PBS.runAsPBSJob(req["Owner"],req["JobID"],job["command"])
					#c = PBS.AddFileWrapper("direct",job["command"],job["inputs"],job["outputs"])
					c=PBS.wrapCmd(job["command"],job["variables"])
					id= PBS.runAsPBSJob(req["Owner"],req["JobID"],c)
					Response.sendData(clientsock,'recieved:'+id)
				clientsock.close()
				
				#JOBS[job["JobID"]][1]='C' 
				#print 'Job with ID: ' + job["JobID"] + ' owned by: ' + job["Owner"] + ' is Completed'
				#print JOBS
			elif (req["requestType"]=="STATUS"):
				#sendData(clientsock,getJobStatus(req))
				status=""
				if ("job_" in req["JobID"]):
					status=Job.checkHadoopStatus(req["JobID"])
				else:
					status=Job.checkPBSstatus(req["JobID"])
				Response.sendData(clientsock,Job.perpareJobStatusMessage(req,status))
			elif (req["requestType"]=="FIND"):
				 if (req["Owner"]=="hadoop"):
					doc = xml.dom.minidom.parseString(msg)
					print msg
					folders=doc.getElementsByTagName("folder")
					Files=[]
					if folders!=None:
							for folder in folders:
									path=folder.getAttribute("path")
									print "listing files in" ,path
									Files=Job.getOutputFiles("hdfs://"+path)
					else:
							Files=Job.getOutputFiles("hdfs:///home/hadoop/outputs/" + req["JobID"])
					response=""
					print 'Files List:', Files
					if 'Cannot access' in Files:
						response = Files
					else:
						response= Response.generateListMessage(msg,Files)
					print response
					Response.sendData(clientsock,response)

			elif (req["requestType"]=="FETCH"):
				#Response.sendData(clientsock,"Entered")
				OutputList = Request.getOutputList(msg)
				file=open("/home/hadoop/tmp/outlist","w")
				file.write(str(OutputList))
				file.close()
				#Response.sendData(clientsock,"wrote log\n"+str(OutputList))
				response = Response.generateResponse(msg,OutputList)
				Response.sendData(clientsock,response)
	#		print ' response: ' , response  
#			clientsock.send(response+"\n\n###")
			else:
					file=open("/home/hadoop/tmp/err",'w')
					file.write("Unsupported Type Recieved")
					file.close()
			break
PBS.run("mkdir /home/hadoop/tmp")
s=startServer()
i=0
while 1:
	clientsock,clientaddr=s.accept()
	i+=1
	print 'Got connection from ' , clientsock.getpeername()
	t=threading.Thread(target=HandleClient,args=[clientsock], name="Thread #" + str(i))
	t.start()

sys.exit(0)
