import socket,base64,time,sys,subprocess
from Crypto.PublicKey import RSA

from Crypto import Random
def importKey():
	
	file=open("/root/EHPC/my",'r')
	st = "".join(file.readlines())
	key = RSA.importKey(st)
	return key


#Provide id, owner and command as string 
# inputsFiles as List of file path
def createJobMessage(id,owner,command,inputsFiles,outputFiles):
	sec=base64.encodestring(importKey().encrypt(id+owner,"")[0])
	f='<job id="' + id + '" owner="' + owner + '" type="SUBMIT" sec="'+sec+'">\n'
	f += '\t<command>'+base64.encodestring(command)+'</command>\n'
	previousPath=""
	if (inputsFiles!=None):
		for file in inputsFiles:
			parts= file.split("/")
			path="/".join(parts[:-1])
			out=open(file+'.64','w')
			base64.encode(open(file,'r'),out)
			out.flush()	
			out.close()
			out=open(file+'.64','r')
			encoded=out.read()	
			out.close()
			if (path != previousPath):
				if (previousPath !=""):	f+="</folder>"
				f += '\t<folder path="' + path  + '">\n'
				f += '\t\t<input filename="'+parts[-1]+'">'+encoded +'</input>\n'
		if(len(inputsFiles)!=0):		
			f+='</folder>\n'
			
	if (outputFiles!=None):	
		for file in outputFiles:
			parts= file.split("/")
			path="/".join(parts[:-1])
			if (path != previousPath):
				if (previousPath !=""):	f+="</folder>"
				previousPath=path
				f += '<folder path="' + path  + '">\n'
				f += '\t<output filename="'+parts[-1]+'"/>'
		if(len(outputFiles)!=0):		
			f+='</folder>\n'
	f+= '</job>'
	
	return f

def FetchOutput(id,owner,outputFiles):
	sec=base64.encodestring(importKey().encrypt(id+owner,"")[0])
	f='<job id="' + id + '" owner="' + owner + '" type="FETCH" sec="' +sec+'">\n'
	previousPath=''
	
	for file in outputFiles:
		parts= file.split("/")
		path="/".join(parts[:-1])
		if (path != previousPath):
			if (previousPath !=""):	f+="</folder>"
			previousPath=path
			f += '<folder path="' + path  + '">\n'
			f += '\t<output filename="'+parts[-1]+'"/>'
	if(len(outputFiles)!=0):		
		f+='</folder>\n'
	f+= '</job>'

	return f
	
	
	
def checkJobStatus(Connect,id,owner):
	sec=base64.encodestring(importKey().encrypt(id+owner,"")[0])
	st =  '<job id="'+id+'" owner="'+owner+'" type="STATUS" sec="' + sec +'"/>'
	while 1:
		res = Connect.Send(st)
		status=res[res.find('status="')+8:][0]
		print 'status of ' + id  + ' = ' + status
		if (status!='R' and status!='Q'): break
		time.sleep(2)
	return status
def parseResponse(message):
        import xml.dom.minidom
        import os
        outputFilesList=[]
        doc = xml.dom.minidom.parseString(message)
        folders=doc.getElementsByTagName("folder")
        for folder in folders:
                path=folder.getAttribute("path")
                print 'In folder:' , path
                if (not os.path.exists(path)): os.makedirs(path)
                outputs = folder.getElementsByTagName("output")
                if (outputs!=None):
                        for output in outputs:
                                filename= output.getAttribute('filename')
                                text=output.firstChild.nodeValue
                                content=base64.decodestring(text)
                                print "file '" , filename + "'\n" + content 
                                file= open(path+"/"+filename,'w')
                                file.write(content)
                                file.flush()
                                file.close()
                                outputFilesList.append(path+'/' +filename)


        print "output files: " , str(outputFilesList)
        return outputFilesList

def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	return p.stdout.read()
