#! /usr/bin/python
import os,sys,simplejson,subprocess,time
region="EU1"
def run(excuter,wait=True):

        PIPE=subprocess.PIPE
        p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
        if (wait):
                p.wait()
                st=p.stderr.read()
                if len(st)>0:
                       return "Error: "+ st
                else:
                        return p.stdout.read()
        else:
                return p

def getMetaInfo(info):
        return run("wget -q -O - http://169.254.169.254/latest/meta-data/%s/"%(info),True)

def attachMount2Me(volID, device,mountPoint,format):
        #return volID
        global region
	instanceID=getMetaInfo("instance-id")
        x=run("./EC2.2 " + region  + " --attach %s %s %s" %(volID,instanceID,device),True)
#       print x 
        time.sleep(10)
        while 1:
                if (os.path.exists('/dev/xvd'+device[-1])):
                        print "Volume mounted, continuing...."
                        break
                else:
                        print "Waiting for AWS to mount Volume, trying again after 5 secs"
                        time.sleep(5)

        cmd=""
        if format=='N':
                cmd= "sudo mount /dev/xvd"+ device[-1] + " " + mountPoint
        else:
                cmd= "sudo mkfs /dev/xvd"  + device[-1] + ";sudo mount /dev/xvd"+ device[-1] + " " + mountPoint

        p=run(cmd,True)
        return p

if __name__=="__main__":
	attachMount2Me(sys.argv[1],sys.argv[2],sys.argv[3],sys.argv[4])
