#! /usr/bin/env python
############################################################################################################
##                                                                                                        ##
## This file is responsible of fetching the input data from the main node or S3 and it returns the output ##
##                                        back to the main node or S3                                     ##
##                                      Written By: Mohamed M. ElKalioby                                  ##
##                                      Created On: June 2011                                             ##
##                                      Updated On: May 2012                                              ##
##                                                                                                        ##
############################################################################################################
 
import sys,socket,os,subprocess

def run(excuter,id=None):

        PIPE=subprocess.PIPE
        p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	(stderr,stdout)=   p.communicate()
        st=stderr
	if (id!=None):
		f = open("/tmp/"+id+".err",'w')
	        f.write(st)
		f.flush()
	        f.close()
  		f = open("/tmp/"+id+".out",'w')
        	f.write(stdout)
	        f.flush()
        	f.close()

	return stderr
def GetItem(src,dest):
#	key.key=name
#	key.get_contents_to_filename(path + name.split('/')[1])
	cmd=('s3cmd -c /home/ubuntu/.s3cfg get %s %s'%(src,dest))
	print cmd
	print run(cmd)
	
	#print key.name

def addItem(src,dest):
	cmd=('s3cmd -c /home/ubuntu/.s3cfg put %s %s'%(src,dest))
	print cmd
	print run(cmd)
	

if __name__=="__main__":
	key=""
	folder=""
	if (socket.gethostname().split("-")[-1]=="0" and sys.argv[1]=="direct"): #MasterNode and files exists
		exit(0)
	else:
		protocol=sys.argv[1]
#		if (protocol=="S3"):
#			print "Init S3...."
#			bucket = conn.get_bucket('eg.nubios')
#			key=Key(bucket)
	
		mode=sys.argv[2]
		files=sys.argv[3].split(",")
		print files
		s=socket.gethostname().split("-")[:-1]
		#s="EU-Cluster5-1".split("-")[:-1]
		s.append("0")
		server = '-'.join(s)
		if (mode=="input"):
			for file in files:
				
				#Create Folder if not exists
				if protocol!="S3":
					folder='/'.join(file.split('/')[:-1])
					if (not os.path.exists(folder)): 
						os.makedirs(folder)
						run ("chmod 777 "  + folder)
					command="scp ubuntu@%s:%s %s" % (server,file,folder)
					run(command,mode) 
				else:
					folder=sys.argv[4]
					GetItem(file,folder)

				#print command
		elif (mode=="output"):
			for file in files:
				if protocol!="S3":
					folder='/'.join(file.split('/')[:-1])
					#if (not os.path.exists(folder)): 
					#	os.makedirs(folder)
					#	run ("chmod 777 "  + folder)
					command="scp %s ubuntu@%s:%s" % (file,server,folder)
					run(command,mode) 
				else:
					print protocol
					#Add Item to S3
					name=sys.argv[4] #    '/'.join(file.split('/')[-2:])
					if name[-1]!='/':
						name+='/'
#					print name
					addItem(file,name)
