#! /usr/bin/python

import sys,os,simplejson
#sys.path.append("/var/www/cluster2/py")
import aws


def lstNodes():
	rows= simplejson.loads(aws.getAllNodes())
	#print rows
	if "rows" in rows.keys():
		rows=rows["rows"]
#		print rows
		machines=[row["cell"][:-1] for row in rows]
		return machines
	else:
		return {'err':"Cluster is n't created yet"}
def getInfo(id):
	info=aws.fetch(id)
	if "Err:" in info:
		return ' '.join(info)
	rows= simplejson.loads(info)
	return  rows
def lstZones():
	return simplejson.loads(aws.getAllZones())	
def lstVols(zone):
#	return "Hello"
	return (aws.avaVolumesZone(zone))
def attachVols(instanceID,volID, device, mountPoint,format):
	return (aws.attachMount(instanceID, volID, device,mountPoint,format))
def createVolume(size, zone):
	return aws.createVolume(size,zone)
def attachSnap(snapshotID,devicePath,mountPoint):
	return aws.attachSnapShot(snapshotID,devicePath,mountPoint)
#def addNode(machineType,count):
#	return aws.addNode(machineType,count)
def addNode(machine,count='1'):
	lst=machine.split(',')
		
	c="/root/EHPC/EHPC-createCluster --add-node -t=%s -n=%s --extraMachinesPBSCores=%s"%(lst[0],count,lst[1])
	print c
#	return c
	print run (c)
#	import time
#	time.sleep(10)
	return "Machine is starting...."

if __name__=="__main__":
	if len(sys.argv)>1:
		if sys.argv[1]=="--lst":
			print simplejson.dumps(lstNodes())
		elif sys.argv[1]=="--info":
			print getInfo(sys.argv[2])
		elif sys.argv[1]=="--lst-Vols":
			print lstVols(sys.argv[2])
		elif sys.argv[1]=="--lst-Zones":
			print simplejson.dumps(lstZones())
		elif sys.argv[1]=="--attach-Vol":
			if len(sys.argv)==7:
				print attachVols(sys.argv[2],sys.argv[3],sys.argv[4],sys.argv[5],sys.argv[6])
			else:
				print """Wrong parameter count command should be as follows:
utils.py --attach-Vol instanceID volID device mountPoint format
e.g.
utils.py --attach-Vol i-356536 vol-11111 /dev/sdx /data1 N/Y
"""
		elif sys.argv[1]=="--create-Vol":
			if len(sys.argv)==3:
				print createVolume(sys.argv[3],sys.argv[2])
			else:
				 print """Wrong parameter count command should be as follows:
utils.py --create-Vol zone size
e.g utils.py --create-Vol eu-west-1a 10"""
		elif sys.argv[1]=="--attach-Snapshot":
			if len(sys.argv)==5:
				print attachSnap(sys.argv[2],sys.argv[3],sys.argv[4])
			else:
				  print """Wrong parameter count command should be as follows:
utils.py --attach-Snap snapshotID devicePath mountPoint
e.g utils.py --attach-Snap snap-3272878 /dev/xvdf /data2"""

		elif sys.argv[1]=="--add-Node":
			if len(sys.argv) == 5:
				print addNode(sys.argv[2]+","+sys.argv[3],sys.argv[4])
			else:
				print """Wrong parameter count command should be as follows:
utils.py --add-Node instanceType count
e.g utils.py --add-Node m1.large 1"""
		elif sys.argv[1]=="--terminate-Node":
			if len(sys.argv) == 3:
                                print aws.terminate(sys.argv[2])
                        else:
                                print """Wrong parameter count command should be as follows:
utils.py --terminate-Node instanceId
e.g utils.py --add-Node i-76476476"""
		else:
			print "Unregonized mode....."

