$(document).ready(function(){
 addSpecialValidators();
    
  });
function addSpecialValidators()
{
 jQuery.validator.addMethod("fasta", function(value, element) { 
  if (value==null) return true;
  if (value.length==0) return true;
  
  lines=value.split("\n")
  if (lines[0].match(/^[>]/))
	return true;
  else return false; 
}, " must be a Fasta file" );

jQuery.validator.addMethod("dna", function(value, element) { 
  if (value==null) return true;
  if (value.length==0) return true;
  var x= value;
  if (x.match(/^([acgt])+$/gi)) return true;
  else return false; 
}, " must be a DNA file" );

jQuery.validator.addMethod("rna", function(value, element) { 
  if (value==null) return true;
  if (value.length==0) return true;
  var res=false;
  var x= value;
  lines = x.split("\n")
  for (var i =0; i <lines.length;i=i+1)
  {
	  if (lines[i].match(/^[>]/)) continue
	  else 
	  {
		if (lines[i].match(/^([acgu])+$/gi)) res = true;
		else
		{
			 res = false; 
			 break;
		}
		
	}
}
return res;
}, " must be a RNA file" );

}


