workflow = null;
canvas_manager = null;
active_ajax_call = false;

//varibales for iterations
var iterationEnable=false;
var iterationID=0;
var currentIteration="";
var currIterationNode="";
var iterationDropped=false;
var selectedToolName="";
//
var iterationArray=[];
var iterationElement=[];
var workflowName;
var owner;
var nodesArrayConnections = {};

//workflow display control variables:
var hideDummyLinks = false;
var hideInputs = false;
var hideStringConstants = false;
var hideLink = false;
var hiddenLinks = new Array();

//array for nodes
var nodesArray=[];
nodesArray['levels'] = new Array();
nodesArray['levels'].push("#workflow");

var promotedOutputs=new Array();
var navigate = false;

(function($) {
  var oldHTML = $.fn.html;

  $.fn.formhtml = function() {
    if (arguments.length) return oldHTML.apply(this,arguments);
    $("input,textarea,button", this).each(function() {
      this.setAttribute('value',this.value);
    });
    $(":radio,:checkbox", this).each(function() {
      // im not really even sure you need to do this for "checked"
      // but what the heck, better safe than sorry
      if (this.checked) this.setAttribute('checked', 'checked');
      else this.removeAttribute('checked');
    });
    $("option", this).each(function() {
      // also not sure, but, better safe...
      if (this.selected) this.setAttribute('selected', 'selected');
      else this.removeAttribute('selected');
    });
    return oldHTML.apply(this);
  };

  //optional to override real .html() if you want
   $.fn.html = $.fn.formhtml;
})(jQuery);


// jQuery onReady
$( function() {
		$.ajax({
			type: "GET",
			url: "../bin/tavaxy/SessionManagement.py",
			async: false,
			cache: false,
			success: function( data ) {
				if(data == "-1"){
					window.location = "../bin/tavaxy/SessionManagement.py/user";
				}
			}
		});
		
		if(!String.prototype.startsWith){
			String.prototype.startsWith = function (str) {
				return !this.indexOf(str);
			}
		}

   
        if ( window.lt_ie_7 ) {
            show_modal(
                "Browser not supported",
                "Sorry, the workflow editor is not supported for IE6 and below."
            );
            return;
        }
   
        // Load jStore for local storage
        $.extend(jQuery.jStore.defaults, { project: 'galaxy', flash: '/static/jStore.Flash.html' });
        $.jStore.load(); // Auto-select best storage
        
        // Canvas overview management
        canvas_manager = new CanvasManager( $("#canvas-viewport"), $("#overview") );
        
        // Initialize workflow state
        reset();
        thedata={"class_to_classes": {"galaxy.datatypes.sequence.FastqSolexa": {"galaxy.datatypes.sequence.FastqSolexa": true, "galaxy.datatypes.sequence.Fastq": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.Fasta": {"galaxy.datatypes.sequence.Fasta": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.FastqIllumina": {"galaxy.datatypes.sequence.Fastq": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.sequence.FastqIllumina": true}, "galaxy.datatypes.binary.Bam": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Binary": true, "galaxy.datatypes.binary.Bam": true}, "galaxy.datatypes.images.Html": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.Gff": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.interval.Gff": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.data.Txtseq": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Txtseq": true}, "galaxy.datatypes.sequence.Fastq": {"galaxy.datatypes.sequence.Fastq": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Snptest": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.genetics.Snptest": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.csFasta": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.csFasta": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.FastqSanger": {"galaxy.datatypes.sequence.Fastq": true, "galaxy.datatypes.sequence.FastqSanger": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.Lav": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Lav": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.images.Laj": {"galaxy.datatypes.images.Laj": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.binary.Sff": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Sff": true, "galaxy.datatypes.binary.Binary": true}, "galaxy.datatypes.qualityscore.QualityScoreIllumina": {"galaxy.datatypes.qualityscore.QualityScore": true, "galaxy.datatypes.qualityscore.QualityScoreIllumina": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Eigenstratgeno": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Eigenstratgeno": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.qualityscore.QualityScoreSOLiD": {"galaxy.datatypes.qualityscore.QualityScore": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.qualityscore.QualityScoreSOLiD": true}, "galaxy.datatypes.genetics.Rgenetics": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.Gff3": {"galaxy.datatypes.interval.Gff3": true, "galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.interval.Gff": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.Interval": {"galaxy.datatypes.interval.Interval": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.tabular.Tabular": true}, "galaxy.datatypes.xml.BlastXml": {"galoadlaxy.datatypes.xml.BlastXml": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.GenomeGraphs": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.GenomeGraphs": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Pheno": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Pheno": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.binary.Ab1": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Ab1": true, "galaxy.datatypes.binary.Binary": true}, "galaxy.datatypes.genetics.Eset": {"galaxy.datatypes.genetics.Eset": true, "galaxy.datatypes.images.Html": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.genetics.RexpBase": true}, "galaxy.datatypes.tabular.Tabular": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.Wiggle": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.interval.Wiggle": true}, "galaxy.datatypes.images.Gmaj": {"galaxy.datatypes.images.Gmaj": true, "galaxy.datatypes.data.Data": true}, "galaxy.datatypes.data.Data": {"galaxy.datatypes.data.Data": true}, "galaxy.datatypes.genetics.Fphe": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Fphe": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.qualityscore.QualityScore454": {"galaxy.datatypes.qualityscore.QualityScore": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.qualityscore.QualityScore454": true}, "galaxy.datatypes.sequence.Maf": {"galaxy.datatypes.sequence.Maf": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Alignment": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.tabular.Taxonomy": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.tabular.Taxonomy": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.SNPMatrix": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.SNPMatrix": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.BedStrict": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.interval.BedStrict": true, "galaxy.datatypes.interval.Interval": true, "galaxy.datatypes.interval.Bed": true, "galaxy.datatypes.tabular.Tabular": true}, "galaxy.datatypes.genetics.Eigenstratpca": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Eigenstratpca": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.tabular.Sam": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.tabular.Sam": true}, "galaxy.datatypes.sequence.Axt": {"galaxy.datatypes.sequence.Axt": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.sequence.FastqCSSanger": {"galaxy.datatypes.sequence.Fastq": true, "galaxy.datatypes.sequence.FastqCSSanger": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.sequence.Sequence": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.tracks.GeneTrack": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Binary": true, "galaxy.datatypes.tracks.GeneTrack": true}, "galaxy.datatypes.binary.Scf": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Binary": true, "galaxy.datatypes.binary.Scf": true}, "galaxy.datatypes.binary.Binseq": {"galaxy.datatypes.binary.Binseq": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.binary.Binary": true}, "galaxy.datatypes.genetics.RexpBase": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.genetics.RexpBase": true}, "galaxy.datatypes.qualityscore.QualityScore": {"galaxy.datatypes.qualityscore.QualityScore": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Pphe": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Pphe": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Pbed": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Pbed": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.data.Text": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.images.Image": {"galaxy.datatypes.data.Data": true, "galaxy.datatypes.images.Image": true}, "galaxy.datatypes.qualityscore.QualityScoreSolexa": {"galaxy.datatypes.qualityscore.QualityScoreSolexa": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.qualityscore.QualityScore": true}, "galaxy.datatypes.genetics.Lped": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Lped": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.coverage.LastzCoverage": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.coverage.LastzCoverage": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.genetics.Fped": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.Fped": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Rgenetics": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.CustomTrack": {"galaxy.datatypes.tabular.Tabular": true, "galaxy.datatypes.interval.CustomTrack": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true}, "galaxy.datatypes.interval.Bed": {"galaxy.datatypes.interval.Bed": true, "galaxy.datatypes.interval.Interval": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.tabular.Tabular": true}, "galaxy.datatypes.chrominfo.ChromInfo": {"galaxy.datatypes.chrominfo.ChromInfo": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.tabular.Tabular": true}, "galaxy.datatypes.genetics.Affybatch": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.genetics.Affybatch": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.genetics.RexpBase": true}, "galaxy.datatypes.genetics.MAlist": {"galaxy.datatypes.images.Html": true, "galaxy.datatypes.genetics.MAlist": true, "galaxy.datatypes.data.Data": true, "galaxy.datatypes.data.Text": true, "galaxy.datatypes.genetics.RexpBase": true}}, "ext_to_class_name": {"newcpgreport": "galaxy.datatypes.data.Text", "primersearch": "galaxy.datatypes.data.Text", "coderet": "galaxy.datatypes.data.Text", "pepstats": "galaxy.datatypes.data.Text", "fastqillumina": "galaxy.datatypes.sequence.FastqIllumina", "scf": "galaxy.datatypes.binary.Scf", "cpgplot": "galaxy.datatypes.data.Text", "gg": "galaxy.datatypes.genetics.GenomeGraphs", "eigenstratgeno": "galaxy.datatypes.genetics.Eigenstratgeno", "checktrans": "galaxy.datatypes.data.Text", "digest": "galaxy.datatypes.data.Text", "newcpgseek": "galaxy.datatypes.data.Text", "binseq.zip": "galaxy.datatypes.binary.Binseq", "cut": "galaxy.datatypes.data.Text", "ncbi": "galaxy.datatypes.data.Text", "prettyseq": "galaxy.datatypes.data.Text", "affybatch": "galaxy.datatypes.genetics.Affybatch", "polydot": "galaxy.datatypes.data.Text", "charge": "galaxy.datatypes.data.Text", "genbank": "galaxy.datatypes.data.Text", "sff": "galaxy.datatypes.binary.Sff", "taxonomy": "galaxy.datatypes.tabular.Taxonomy", "selex": "galaxy.datatypes.data.Text", "match": "galaxy.datatypes.data.Text", "cusp": "galaxy.datatypes.data.Text", "embl": "galaxy.datatypes.data.Text", "srspair": "galaxy.datatypes.data.Text", "pepinfo": "galaxy.datatypes.data.Text", "dan": "galaxy.datatypes.data.Text", "lped": "galaxy.datatypes.genetics.Lped", "qual454": "galaxy.datatypes.qualityscore.QualityScore454", "vectorstrip": "galaxy.datatypes.data.Text", "etandem": "galaxy.datatypes.data.Text", "chips": "galaxy.datatypes.data.Text", "syco": "galaxy.datatypes.data.Text", "eigenstratpca": "galaxy.datatypes.genetics.Eigenstratpca", "array_tree": "galaxy.datatypes.data.Data", "showfeat": "galaxy.datatypes.data.Text", "pbed": "galaxy.datatypes.genetics.Pbed", "bam": "galaxy.datatypes.binary.Bam", "xls": "galaxy.datatypes.tabular.Tabular", "isochore": "galaxy.datatypes.data.Text", "interval_index": "galaxy.datatypes.data.Data", "dbmotif": "galaxy.datatypes.data.Text", "fastqcssanger": "galaxy.datatypes.sequence.FastqCSSanger", "gff": "galaxy.datatypes.interval.Gff", "txt": "galaxy.datatypes.data.Text", "customtrack": "galaxy.datatypes.interval.CustomTrack", "cpgreport": "galaxy.datatypes.data.Text", "clustal": "galaxy.datatypes.data.Text", "sixpack": "galaxy.datatypes.data.Text", "btwisted": "galaxy.datatypes.data.Text", "fuzztran": "galaxy.datatypes.data.Text", "blastxml": "galaxy.datatypes.xml.BlastXml", "qualsolid": "galaxy.datatypes.qualityscore.QualityScoreSOLiD", "staden": "galaxy.datatypes.data.Text", "malist": "galaxy.datatypes.genetics.MAlist", "wordcount": "galaxy.datatypes.data.Text", "len": "galaxy.datatypes.chrominfo.ChromInfo", "strider": "galaxy.datatypes.data.Text", "palindrome": "galaxy.datatypes.data.Text", "pepcoil": "galaxy.datatypes.data.Text", "markx1": "galaxy.datatypes.data.Text", "markx0": "galaxy.datatypes.data.Text", "dreg": "galaxy.datatypes.data.Text", "markx2": "galaxy.datatypes.data.Text", "supermatcher": "galaxy.datatypes.data.Text", "mega": "galaxy.datatypes.data.Text", "codcmp": "galaxy.datatypes.data.Text", "phylip": "galaxy.datatypes.data.Text", "garnier": "galaxy.datatypes.data.Text", "ab1": "galaxy.datatypes.binary.Ab1", "jackknifernon": "galaxy.datatypes.data.Text", "pdf": "galaxy.datatypes.images.Image", "compseq": "galaxy.datatypes.data.Text", "nametable": "galaxy.datatypes.data.Text", "wig": "galaxy.datatypes.interval.Wiggle", "helixturnhelix": "galaxy.datatypes.data.Text", "rexpbase": "galaxy.datatypes.genetics.RexpBase", "acedb": "galaxy.datatypes.data.Text", "simple": "galaxy.datatypes.data.Text", "fastqsolexa": "galaxy.datatypes.sequence.FastqSolexa", "codata": "galaxy.datatypes.data.Text", "qualsolexa": "galaxy.datatypes.qualityscore.QualityScoreSolexa", "phylipnon": "galaxy.datatypes.data.Text", "fuzznuc": "galaxy.datatypes.data.Text", "table": "galaxy.datatypes.data.Text", "bedstrict": "galaxy.datatypes.interval.BedStrict", "seqtable": "galaxy.datatypes.data.Text", "score": "galaxy.datatypes.data.Text", "wobble": "galaxy.datatypes.data.Text", "preg": "galaxy.datatypes.data.Text", "csfasta": "galaxy.datatypes.sequence.csFasta", "gif": "galaxy.datatypes.images.Image", "gmaj.zip": "galaxy.datatypes.images.Gmaj", "equicktandem": "galaxy.datatypes.data.Text", "markx3": "galaxy.datatypes.data.Text", "markx10": "galaxy.datatypes.data.Text", "freak": "galaxy.datatypes.data.Text", "tagseq": "galaxy.datatypes.data.Text", "meganon": "galaxy.datatypes.data.Text", "needle": "galaxy.datatypes.data.Text", "fuzzpro": "galaxy.datatypes.data.Text", "qual": "galaxy.datatypes.qualityscore.QualityScore", "jpg": "galaxy.datatypes.images.Image", "msf": "galaxy.datatypes.data.Text", "hmoment": "galaxy.datatypes.data.Text", "png": "galaxy.datatypes.images.Image", "showorf": "galaxy.datatypes.data.Text", "qualillumina": "galaxy.datatypes.qualityscore.QualityScoreIllumina", "bed": "galaxy.datatypes.interval.Bed", "rgenetics": "galaxy.datatypes.genetics.Rgenetics", "eset": "galaxy.datatypes.genetics.Eset", "cai": "galaxy.datatypes.data.Text", "textsearch": "galaxy.datatypes.data.Text", "jackknifer": "galaxy.datatypes.data.Text", "pphe": "galaxy.datatypes.genetics.Pphe", "nexusnon": "galaxy.datatypes.data.Text", "fphe": "galaxy.datatypes.genetics.Fphe", "motif": "galaxy.datatypes.data.Text", "epestfind": "galaxy.datatypes.data.Text", "sam": "galaxy.datatypes.tabular.Sam", "nexus": "galaxy.datatypes.data.Text", "fastq": "galaxy.datatypes.sequence.Fastq", "snptest": "galaxy.datatypes.genetics.Snptest", "tabular": "galaxy.datatypes.tabular.Tabular", "fastqsanger": "galaxy.datatypes.sequence.FastqSanger", "pir": "galaxy.datatypes.data.Text", "fasta": "galaxy.datatypes.sequence.Fasta", "ig": "galaxy.datatypes.data.Text", "txtseq.zip": "galaxy.datatypes.data.Txtseq", "genetrack": "galaxy.datatypes.tracks.GeneTrack", "gcg": "galaxy.datatypes.data.Text", "pheno": "galaxy.datatypes.genetics.Pheno", "gff3": "galaxy.datatypes.interval.Gff3", "hennig86": "galaxy.datatypes.data.Text", "excel": "galaxy.datatypes.data.Text", "feattable": "galaxy.datatypes.data.Text", "regions": "galaxy.datatypes.data.Text", "html": "galaxy.datatypes.images.Html", "noreturn": "galaxy.datatypes.data.Text", "srs": "galaxy.datatypes.data.Text", "laj": "galaxy.datatypes.images.Laj", "fped": "galaxy.datatypes.genetics.Fped", "fitch": "galaxy.datatypes.data.Text", "coverage": "galaxy.datatypes.coverage.LastzCoverage", "maf": "galaxy.datatypes.sequence.Maf", "pair": "galaxy.datatypes.data.Text", "lav": "galaxy.datatypes.sequence.Lav", "data": "galaxy.datatypes.data.Data", "est2genome": "galaxy.datatypes.data.Text", "axt": "galaxy.datatypes.sequence.Axt", "asn1": "galaxy.datatypes.data.Text", "interval": "galaxy.datatypes.interval.Interval", "diffseq": "galaxy.datatypes.data.Text", "snpmatrix": "galaxy.datatypes.genetics.SNPMatrix", "geecee": "galaxy.datatypes.data.Text", "einverted": "galaxy.datatypes.data.Text", "swiss": "galaxy.datatypes.data.Text"}};
        //
        //json

		workflowName = querySt("workflowName");
		owner = querySt("owner");
		if(!owner){
			owner="";
		}
		else{
			$("#execute").hide();
		}
		

		$("#dialog-form").dialog({
			autoOpen: false,
			height: 200,
			width: 350,
			modal: true,
			buttons: {
				'Save': function() {
					workflowName = $("#wfName").val();
					workflowXML = CreateXML();
					workflowXML = escape(workflowXML);
					if($("#overwrite").is(':checked'))
					{
					    SaveXMLDoc(workflowName, workflowXML, true);
					}
					else
					{
					    SaveXMLDoc(workflowName, workflowXML, false);
					}
					if (navigate)					
					{
						ExecuteWorkflow();
					}
					$(this).dialog('hide');
				},
				
			},
			close: function() {
				if (navigate)					
				{
					ExecuteWorkflow();
				}
				$(this).dialog('hide');
			}
		});
		

   		
		////////////////automatic tool list retrieval//////////////////////////////////////////////
	   		   	$.ajax({
			url: "../bin/tavaxy/Editor.py/GetAvailableTools",	 
			type:'GET',               
		        dataType: 'html',
		        cache: false,
			success: function(data){
				$('#toolList').html(data);
				$("#toolMenu").accordion({ autoHeight: false, collapsible: true, active: false });
				$("#toolMenu").accordion();
				$("#mainButton").accordion({ autoHeight: false,collapsible: true });
				$("#mainButton").accordion();
				$(".button").button();

				/*
				$('#toolList').html(data);
				$( "div.toolSectionBody" ).hide();
				$( "div.toolSectionTitle > span" ).wrap( "<a href='#'></a>" );
				var last_expanded = null;
				$( "div.toolSectionTitle" ).each( function() { 
				   var body = $(this).next( "div.toolSectionBody" );
				   $(this).click( function() {
					   if ( body.is( ":hidden" ) ) {
						   if ( last_expanded ) last_expanded.slideUp( "fast" );
						   last_expanded = body;
						   body.slideDown( "fast" );
					   }
					   else {
						   body.slideUp( "fast" );
						   last_expanded = null;
					   }
				   });
				});
				*/
			}
   		});
   		////////////////end of automatic tool list retrieval//////////////////////////////////////
		

		function querySt(ji){
                    hu = window.location.search.substring(1);
                    gy = hu.split("&");
                    for (i = 0; i < gy.length; i++) {
                        ft = gy[i].split("=");
                        if (ft[0] == ji) {
                            return ft[1];
                        }
                    }
                }
				
		function GenerateXML(xml, workflowArray)
		{
				xml.BeginNode("s:scufl");
				xml.Attrib("xmlns:s", "http://org.embl.ebi.escience/xscufl/0.1alpha");
				xml.BeginNode("s:workflowdescription");
				xml.Attrib("title", "workflow");
				xml.EndNode();
				for (i in connectionsArray) 
				{
					if (connectionsArray[i]) 
					{
						var sourceNode = connectionsArray[i]["sourceName"];
						var sourceParent = findParent(sourceNode);
						if (sourceParent[sourceNode]) 
						{
							var sinkNode = connectionsArray[i]["sinkName"];
							sinkParent = findParent(sinkNode);
							if (sinkParent[sinkNode]) 
							{
								if (sourceParent[sourceNode]["type"] == "input") 
								{
									var source = sourceNode;
									sourcePort = "output";
								}
								else 
								{
									var sourcePort = connectionsArray[i]["sourcePortName"];
									var source = sourceNode + ":" + sourcePort;		
								}
								var sinkPort = connectionsArray[i]["sinkPortName"];
								var sink = sinkNode + ":" + sinkPort;
								
								var sourceNode = GetNodeByName(sourceNode);
								var sinkNode = GetNodeByName(sinkNode);
								if(sinkNode["input_terminals"][sinkPort] && sourceNode["output_terminals"][sourcePort]){
									xml.BeginNode("s:link");
									xml.Attrib("source", source);
									xml.Attrib("sink", sink);
									xml.Attrib("ignore", "false");
									xml.EndNode();
								}
								else{
									connectionsArray[i]=null;
								}
								
							}
						}
						
					}
				}
				var sinks = 1;
				for (i in promotedOutputs)
				{
					if (promotedOutputs[i])
					{
						xml.BeginNode("s:sink")
						xml.Attrib("name","output"+sinks)
						xml.Attrib("mappedTo",i)
						sinks += 1;
						xml.EndNode();
					}
				}
				GraphToXML(xml, nodesArray);
				xml.EndNode();
			}

		function SaveXMLDoc(name, workflow, overwrite)
		{
				workflowName = name.replace(/ /g, "_");
				$.ajax
				({
					type: 'POST',
					url: '../bin/tavaxy/Editor.py/SaveWorkflow',
					async: false,
					data: 'name=' + workflowName + '&workflow=' + workflow + '&overwrite=' + overwrite,
					success: function(data)
					{
						alert(data);
						$("#execute").show();
					}
				});
		}

	function LoadNodes(id,step,nested)
	{
		if (step.type == 'input')
		{
			add_node_for_input( "data_input", step.name);
			var node = workflow.active_node;
			nodesArrayConnections[step.name]=node;
			node.element.css({ top: step.y, left: step.x });		
			var parent = findParent(id);
			parent[id]["x"] = step.x;		
			parent[id]["y"] = step.y;		
		}
		else
		{

			if (step.id == "iteration")
			{	
				
				if (nested)
				{
					addIteration(step.id,id,true,step.props);
					var node = workflow.active_node;
					//node.element.css({ top: step.y, left: step.x });
					var parent = findParent(id);
					parent[id]["x"] = step.x;		
					parent[id]["y"] = step.y;		
				}
				else
				{
					add_node_for_node( step.id, step.name,step.props);
					var node = workflow.active_node;
					node.element.css({ top: step.y, left: step.x });
					var parent = findParent(id);
					parent[id]["x"] = step.x;		
					parent[id]["y"] = step.y;		
				}
				var parent = findParent(id);
				parent[id]["parameters"] = {};
				
				$.each(step.params, function(name, param) 
				{
					if(name == "feedbackInputPorts")
					{
						var inputPorts = param.toString().split(",");
						parent[id]["parameters"]["inputPorts"] = new Array();
						for(inputPort in inputPorts)
						{
							parent[id]["parameters"]["inputPorts"].push(inputPorts[inputPort]);	
						}
					}
					else if(name == "feedbackOutputPorts")
					{
						var outputPorts = param.toString().split(",");
						parent[id]["parameters"]["outputPorts"] = new Array();
						for(outputPort in outputPorts)
						{
							parent[id]["parameters"]["outputPorts"].push(outputPorts[outputPort]);
						}
					}
					else 
					{
						parent[id]["parameters"][name] = param;
					}
				});
				
				//parent[id]["parameters"] = step.toolParams;				
				$.each(step.workflow.nodesArray, function(nid, nstep) 
				{
					currIterationNode = step.name;
					LoadNodes(nid,nstep,true);
				});


			}
			else
			{
				
				if (nested)
				{
					addIteration(step.id,id,true,step.params);
					var parent = findParent(id);
					var node = workflow.active_node;
					nodesArrayConnections[step.name]=node;
					//node.element.css({ top: step.y, left: step.x });
					parent[id]["x"] = step.x;		
					parent[id]["y"] = step.y;		
				}
				else
				{
					nodesArrayConnections[step.name] = add_node_for_node( step.id, step.name,step.params);
					var parent = findParent(id);
					var node = workflow.active_node;
					nodesArrayConnections[step.name]=node;
					node.element.css({ top: step.y, left: step.x });
					parent[id]["x"] = step.x;		
					parent[id]["y"] = step.y;		
				}
				var parent = findParent(id);
				parent[id]["parameters"] = step.toolParams;
			}
		}
		
	}

	function alertWorld(){
		alert("Hello World");
	}	
	
	function GetNodeID(nodeName)
	{
		var outputID = "";
		$.each(workflow.nodes, function(id, item)
		{
			if (item["name"] == nodeName)
			{
				outputID = id;
			}
		});
		return outputID;
	}
	
	function _LoadWorkflow(data,workflowName)
	{
		wf = this;
		var max_id = 0;
		wf.name = workflowName;
		// First pass, nodes
		
		$.each(data.nodesArray, function(id, step) {
			LoadNodes(id,step,false);
		});
		nodesArrayConnections["#|#|#|#"] = "loading workflow";
		
		wf.id_counter = max_id + 1;
		// Second pass, connections
		$.each(data.connectionsArray, function(id, connection) {

			var node = workflow.nodes[GetNodeID(connection.sinkName)];	
			connectionElement = [];
			connectionElement["sourceName"] = connection.sourceName;
			connectionElement["sourcePortName"] = connection.sourcePortName;
			connectionElement["sinkName"] = connection.sinkName;
			connectionElement["sinkPortName"] = connection.sinkPortName;
			connectionsArray[connection.sourceName + connection.sourcePortName + connection.sinkName + connection.sinkPortName] = connectionElement;
			var other_node = workflow.nodes[nodesArrayConnections[connection.sourceName]["id"]];
			var c = new Connector();
		  	if(nodesArrayConnections[connection.sourceName]["type"]=="data_input"){
			   	k = connection.sinkPortName;
		          	c.connect(other_node.output_terminals["output"],node.input_terminals[k]);
			}
			else{
				k = connection.sinkPortName;
				c.connect(other_node.output_terminals[connection.sourcePortName],node.input_terminals[k]);
			}
		    c.redraw();

		});
		for (i in data.sinkElements)
		{
			//alert(data.sinkElements[i]);
			promotedOutputs[data.sinkElements[i]]=true;
			$('[id="'+data.sinkElements[i]+'"]').css("background","#006666");
			$('[id="'+data.sinkElements[i]+'"]').css("color","white");
		}
		alert("Workflow Loaded Successfully");
	}
			
		getData(thedata);
        function getData( data ) {
                populate_datatype_info( data );
                // Load workflow definition
                
                if(workflowName)
                {
					$.ajax({
						type: "POST",
						url: "../bin/tavaxy/WorkflowJSON.py/RetrieveWorkflowJSON",
						data: {workflowName:workflowName,owner:owner},
						dataType: 'json',
						cache: false,
						success: function( data ) {
							 _LoadWorkflow(data,workflowName);					
						},
						error: function() {
							 alert("unable to load workflow");
						}
					});
				}
		}
             
        $.jStore.ready(function(engine) {
            engine.ready(function() {
                // On load, set the size to the pref stored in local storage if it exists
                overview_size = $.jStore.store("overview-size");
                if (overview_size) {
                    $("#overview-border").css( {
                        width: overview_size,
                        height: overview_size
                    });
                }
                
                // Show viewport on load unless pref says it's off
                if ($.jStore.store("overview-off")) {
                    hide_overview();
                } else {
                    show_overview();
                }
            });
        });
        
        // Stores the size of the overview into local storage when it's resized
        $("#overview-border").bind( "dragend", function( e ) {
            var op = $(this).offsetParent();
            var opo = op.offset();
            var new_size = Math.max( op.width() - ( e.offsetX - opo.left ),
                                     op.height() - ( e.offsetY - opo.top ) );
            $.jStore.store("overview-size", new_size + "px");
        });
        
        function show_overview() {
            $.jStore.remove("overview-off");
            $("#overview-border").css("right", "0px");
            $("#close-viewport").css("background-position", "0px 0px");
        }
        
        function hide_overview() {
            $.jStore.store("overview-off", true);
            $("#overview-border").css("right", "20000px");
            $("#close-viewport").css("background-position", "12px 0px");
        }
        
        // Lets the overview be toggled visible and invisible, adjusting the arrows accordingly
        $("#close-viewport").click( function() {
            $("#overview-border").css("right") == "0px" ? hide_overview() : show_overview();
        });
        
        // Unload handler
        window.onbeforeunload = function() {
            if ( workflow && workflow.has_changes ) {
                return "There are unsaved changes to your workflow which will be lost.";
            }
        };


        // Rename async.
        async_save_text("workflow-name", "workflow-name", "/workflow/rename_async?id=db2edea29d6dc127", "new_name");
        
        // Tag async. Simply have the workflow edit element generate a click on the tag element to activate tagging.
        $('#workflow-tag').click( function() {
            $('.tag-area').click();
            return false;
        });
        // Annotate async.
        async_save_text("workflow-annotation", "workflow-annotation", "/workflow/annotate_async?id=db2edea29d6dc127", "new_annotation", 25, true, 4);
        
	function CreateXML()
	{
	    var XMLall = new XMLWriter();
	    GenerateXML(XMLall, nodesArray);
	    XMLall.Close();
	    return XMLall.ToString().replace(/</g, "\n<");
	}

       $("#execute").live('click', function(event){
			navigate = true;
			$('#dialog-form').dialog('open');	    
        });

	function ExecuteWorkflow()
	{
		window.location.href = "execWorkflow.htm?workflowName=" + workflowName
	}
        $("#save").live('click', function(event){
			prop();
            $('#dialog-form').dialog('open');
        });

		function GraphToXML(xml, workflowArray)
		{
			
			nodes = workflow.nodes;
			$.each(nodes,function(key,value)
			{
				//alert(value.name)
				var parent = findParent(value.name);
				parent[value.name]["x"]= value.element.position().left+'';
				parent[value.name]["y"]= value.element.position().top+'';
				//alert(value.element.position().top);
				//alert(value.element.position().left);
			});
			for (i in workflowArray) 
			{			
				if (i != "levels")
				{
					if (workflowArray[i] != null) 
					{
						switch (workflowArray[i]["type"]) 
						{
							case "tool":
								switch (workflowArray[i]["id"]) 
								{
									case "iteration":
										xml.BeginNode("s:processor"); //begin iteration processor
										xml.Attrib("name", workflowArray[i]["name"]);
										xml.Attrib("id", workflowArray[i]["id"]);
										xml.Attrib("x", workflowArray[i]["x"]);
										xml.Attrib("y", workflowArray[i]["y"]);
										xml.BeginNode("s:properties"); //begin iteration properties
										xml.BeginNode("s:condition"); //begin iteration condition
										xml.BeginNode("port"); //begin iteration port
										if (workflowArray[i]['parameters']) {
											xml.WriteString(workflowArray[i]['parameters']['port']);
										}
										else {
											xml.WriteString("-1");
										}
										xml.EndNode(); //end iteration port
										xml.BeginNode("operator"); //begin iteration operator
										if (workflowArray[i]['parameters']) {
											xml.WriteString(workflowArray[i]['parameters']['operator']);
										}
										else {
											xml.WriteString("-1");
										}
										xml.EndNode(); //end iteration operator
										xml.BeginNode("value"); //begin iteration value
										if (workflowArray[i]['parameters']) {
											xml.WriteString(workflowArray[i]['parameters']['value']);
										}
										else {
											xml.WriteString("-1");
										}
										xml.EndNode(); //end iteration value
										xml.EndNode(); //end iteration condition
										xml.BeginNode("s:feedback"); //beign iteration feedback
										xml.BeginNode("inputports"); //begin feedback inputs
										if (workflowArray[i]['parameters']) {
											for (inputPort in workflowArray[i]['parameters']["inputPorts"]) {
												xml.BeginNode("port");
												xml.WriteString(workflowArray[i]['parameters']["inputPorts"][inputPort]);
												xml.EndNode();
											}
										}
										xml.EndNode(); //end feedback inputs
										xml.BeginNode("outputports"); //begin feedback outputs
										if (workflowArray[i]['parameters']) {
											for (outputPort in workflowArray[i]['parameters']["outputPorts"]) {
												xml.BeginNode("port");
												xml.WriteString(workflowArray[i]['parameters']["outputPorts"][outputPort]);
												xml.EndNode();
											}
										}
										xml.EndNode(); //end feedback outputs
										xml.EndNode(); //end iteration feedback
										xml.EndNode(); //end iteration properties
										xml.BeginNode("s:scufl");
								        xml.Attrib("xmlns:s", "http://org.embl.ebi.escience/xscufl/0.1alpha");
								        xml.BeginNode("s:workflowdescription");
								        xml.Attrib("title", "workflow");
								        xml.EndNode();
	                                    GraphToXML(xml,workflowArray[i]["workflow"]);
										xml.EndNode();                                                            
	                                    xml.EndNode()
										break;
									case "taverna":
										xml.BeginNode("s:processor");
										xml.Attrib("name", workflowArray[i]["name"]);
										xml.Attrib("id", workflowArray[i]["id"]);
										xml.Attrib("x", workflowArray[i]["x"]);
										xml.Attrib("y", workflowArray[i]["y"]);
										xml.WriteString(workflowArray[i]["orgId"]);
										if (workflowArray[i]['parameters']) {
											for (p in workflowArray[i]["parameters"]) {												
												xml.BeginNode("s:parameter")
												xml.Attrib("name", p);
												xml.WriteString(workflowArray[i]["parameters"][p]);
												xml.EndNode();
											}
										}
										xml.EndNode();
										break;
									default:
										xml.BeginNode("s:processor");
										xml.Attrib("name", workflowArray[i]["name"]);
										xml.Attrib("id", workflowArray[i]["id"]);
										xml.Attrib("x", workflowArray[i]["x"]);
										xml.Attrib("y", workflowArray[i]["y"]);
										if (workflowArray[i]['parameters']) {
											for (p in workflowArray[i]["parameters"]) {
												if (!p.startsWith("__")){
													xml.BeginNode("s:parameter")
													xml.Attrib("name", p);
													xml.WriteString(workflowArray[i]["parameters"][p]);
													xml.EndNode();
												}
											}
										}
										xml.EndNode();
										break;
								}
								break;
							case "input":
								xml.BeginNode("s:source");
								xml.Attrib("name", workflowArray[i]["name"]);
								xml.Attrib("x", workflowArray[i]["x"]);
								xml.Attrib("y", workflowArray[i]["y"]);
								xml.EndNode();
								break;
						}

					}
				
			}
		}
		
		
			
			
			
			$(".close").live('click', function(){
				$(".pop").slideFadeToggle();
				$("#contact").removeClass("selected");
				return false;
			});
			
			

			
						
			$.fn.slideFadeToggle = function(easing, callback){
				return this.animate({
					opacity: 'toggle',
					height: 'toggle'
				}, "fast", easing, callback);
			};
		}

	});

// Global state for the whole workflow
function reset() {
    if ( workflow ) {
        workflow.remove_all();
    }
    workflow = new Workflow( $("#canvas-container") );
}
    
function scroll_to_nodes() {
    var cv = $("#canvas-viewport");
    var cc = $("#canvas-container")
    var top, left;
    if ( cc.width() < cv.width() ) {
        left = ( cv.width() - cc.width() ) / 2;
    } else {
        left = 0;
    }
    if ( cc.height() < cv.height() ) {
        top = ( cv.height() - cc.height() ) / 2;
    } else {
        top = 0;
    }
    cc.css( { left: left, top: top } );
}

//this function changes the properties of a node such that Tavaxy executes it over taverna
function checkboxx()
{
	var nodesName = $('input[type=checkbox]').attr('name');
	var parent = findParent(nodesName);
	if ($('input[type=checkbox]').is(':checked')) {
		parent[nodesName]['orgId'] = parent[nodesName]['id'];
		parent[nodesName]['id'] = 'taverna';
	}
	else 
	{
		parent[nodesName]['id'] = nodesArray[nodesName]['orgId'];
	}
	
}

//for iteration
function addIteration(id,title,loaded,params,nodeData)
{
	if(id != "section")
	{
		var node;
		iterationEnable=true;
		if (!loaded)
		{
			node = add_node_for_tool(id,title);
		}
		else
		{
			node = add_node_for_node(id,title,params,nodeData);
		}
		var parent = findParent(node.name,true);
		while(parent != nodesArray)
		{
			parent["input_ports"] = {};
			$.each( node.input_terminals, function( k, v ) {
				//alert(node.name+":"+v.name);
				parent["input_ports"][node.name+":"+v.name] = true;
			});
			parent["output_ports"] = {};
			$.each( node.output_terminals, function( k, v ) {
				//alert(node.name+":"+v.name);
				parent["output_ports"][node.name+":"+v.name] = true;
			});
			parent = findParent(parent["name"],true);
		}
		iterationEnable=false;        
	}
	return node;
}


function test()
{
	alert("test");
}

function DictToString(dict){
	var params = "{"
	$.each(dict,function(k,v){
		if(typeof(v) == 'object'){
			v = DictToString(v);
		}
		else{
			v = '"' + v + '"';
		}
		params += "\"" + k + "\":" + v + "," ;
	});
	if(params!="{"){
		params = params.slice(0,-1);
	}
	params += "}";
	return params
}

function ReloadTool(){	
	var toolParams = prop();
	var node = workflow.active_node;
	var title = node.name;
	var tool_id = node.tool_id;
	
	var params = DictToString(toolParams);	

	$.ajax({
		url: "../bin/tavaxy/Editor.py/GetToolJson",
		data: "toolID=" + tool_id + "&params=" + params.replace(/ /g,"__ss__").replace("&","__and__"),	 
		type:'GET',           
		dataType: 'json',
		async: false,
		cache: false,
		success: function(data){
			data.form_html = data.form_html.replace(/###/g,title);
			data.name = title;
			var parent = findParent(title);
			node.destroy();
			if (parent != nodesArray){
				addIteration(tool_id,title,true,null,data);
			}
			else{			
				add_node_for_node(tool_id,title,params,data);
			}
		}});
	
}

function GetAvailableClusters(){
	var availableClusters = "";
	$.ajax({
				type: 'GET',
				url: '../bin/tavaxy/Editor.py/GetAvailableClusters',
				async: false,
				success: function(data){
					availableClusters = data;
				}
			});
	return availableClusters;
}

function InfrastructureChanged(element){
	var parent = $("#infrastructure").parent();
	var element = $(element);
	var infrastructure = element.val();
	if(infrastructure=="cloud"){
		parent.append(GetAvailableClusters());
	}
	else if(infrastructure=="local"){
		parent.html("<div class='form-row toolParam' type='select' id='infrastructure'><label>Execute this node on</label><select onChange='InfrastructureChanged(this)'><option value='local'>Local</option><option value='cloud'>Cloud</option></select></div>");
	}
}

function LoadSubWorkflow(element){
	element = $(element);
	var workflowPath = element.val();
	params = "{'workflowPath':'"+workflowPath+"'}";
	if (workflowName != "")
	{
		title = $(".availableWorkflows").attr("toolName");
		$.ajax({
			type: 'POST',
			url: '../bin/tavaxy/Editor.py/LoadSubWorkflow',
			async: false,
			data: 'workflowPath='+workflowPath+'&title='+title+'&owner='+owner,
			dataType: 'json',
			success: function(data){
				var parent = findParent(title);
				data.form_html = data.form_html.replace(/###/g,title);
				var node = workflow.active_node;
				node.destroy();
				if (parent != nodesArray)
				{
					addIteration("subworkflow",title,true,null,data);
				}
				else
				{			
					add_node_for_node("subworkflow",title,params,data);
				}
				prop();
				//add_new_node("subworkflow",title,data);
			}
		});
	}
}

function SaveScript()
{
	workflow.active_form_has_changes = true;
	toolName = $(".script").attr('toolName');
	var scriptName = $(".availableScripts").val();
	if (scriptName == "")
	{
		scriptName = prompt("please enter script's name", "");
	}
	else
	{
		alert(scriptName);
	}
	script = $(".script").val();
	script = escape(script);
	$.ajax({
		type: 'POST',
		url: '../bin/tavaxy/Editor.py/SaveScript',
		async: false,
		data: 'script='+script+'&scriptName='+scriptName,
		success: function(data){
			var parent = findParent(toolName);
			parent[toolName]["parameters"] = new Array();
			parent[toolName]["parameters"]["script"] = data;
			alert("Script is saved");
	 	}
	});

}

function ReloadAvailableScripts(){
	$.ajax({
		type: 'POST',
		url: '../bin/tavaxy/Editor.py/ReloadAvailableWorkflows',
		async: false,
		success: function(data){
			$(".availableWorkflows").html(data);	
	 	}
	});
}

function ReloadAvailableScripts(){
	$.ajax({
		type: 'POST',
		url: '../bin/tavaxy/Editor.py/ReloadAvailableScripts',
		async: false,
		success: function(data){
			$(".availableScripts").html(data);	
	 	}
	});
}

function LoadScript(scriptName)
{
	$.ajax({
		type: 'POST',
		url: '../bin/tavaxy/Editor.py/LoadScript',
		async: false,
		data: 'scriptName='+scriptName,
		success: function(data){
			$(".script").val(data);	
	 	}
	});
	SaveScript();
}


function Promote()
{
	var title = $('[class=prop]').attr('name');
	$('.nodeOutputs').each(function()
	{	
		if ($(this).is(':checked'))
		{
			promotedOutputs[title + "|" + $(this).attr('name')]=true;
			$('[id="'+title + '|' + $(this).attr('name')+'"]').css("background","#006666");
			$('[id="'+title + '|' + $(this).attr('name')+'"]').css("color","white");
		}
	});	
}
function Depromote()
{
	var title = $('[class=prop]').attr('name');
	$('.nodeOutputs').each(function()
	{	
		if ($(this).is(':checked'))
		{
			promotedOutputs[title + "|" + $(this).attr('name')]=false;
			$('[id="'+title + '|' + $(this).attr('name')+'"]').css("background","transparent");
			$('[id="'+title + '|' + $(this).attr('name')+'"]').css("color","black");
		}
	});	

}

function IncrementRepeat(element){
	element = $(element);
	element.parent().attr("id");
	repeatName = element.parent().attr("id");
	repeatHiddenField = $("#__repeats_"+repeatName);
	repeats = parseInt(repeatHiddenField.attr("value"));
	repeats++;
	repeatHiddenField.val(repeats);
	ReloadTool();
}

function DecrementRepeat(element){
	element = $(element);
	element.parent().attr("id");
	var repeatName = element.parent().attr("id");
	var skippedInstance = element.attr("id").split("__repeat_"+repeatName+"_")[1];
	var repeatHiddenField = $("#__repeats_"+repeatName);
	var skippedInstances = repeatHiddenField.attr("skip");
	skippedInstances += skippedInstance + ",";
	repeatHiddenField.attr("skip",skippedInstances);
	ReloadTool();
}

function IsDictEmpty(dict){
	var temp = DictToString(dict);
	if(temp.length > 2){
		return false;
	}
	else{
		return true;
	}
}

function prop()
{
	workflow.active_form_has_changes = true;
	var toolParams = {};
	var title = $('[class=prop]').attr('name');
	var id = $('[class=prop]').attr('id');
	var parent = findParent(title);
	
	
	var repeats = {}
	$('.repeat').each(function(){
		var repeatValue = $(this).attr("value");
		var repeatName = $(this).attr("id").split("__repeats_")[1];
		var skippedInstances = $(this).attr("skip");
		
		repeats[repeatName] = {};
		repeats[repeatName]["repeats"] = repeatValue;
		repeats[repeatName]["skip"] = skippedInstances;
	});
	
	if(!IsDictEmpty(repeats)){
		if(toolParams["__repeats"]){
			toolParams["__repeats"][repeatName] = repeats;
		}
		else{
			toolParams["__repeats"] = repeats;
		}
	}
	
	$('.toolParam').each(function()
	{	
		type = $(this).attr('type');
		id = $(this).attr('id');
		switch(type)
		{
			case "boolean":
				element = $(this).children($("input:first"));
				if(element.is(':checked'))
				{
					toolParams[id]=$(this).attr('truevalue');
				}
				else
				{
					toolParams[id]=$(this).attr('falsevalue');
				}
				break;
			case "select":				
				if($(this).attr('multiple') == "True"){
					separator = $(this).attr('separator');
					elements = $(this).find("input");	
					toolParams[id]=""
					$.each( elements, function(){
						if ($(this).is(':checked')){
							toolParams[id] += $(this).attr("value") + separator;
						}
					});
					toolParams[id] = toolParams[id].slice(0,-1);
				}
				else{
					element = $(this).find("select:first");	
					if (element.val()){
						if(element.parent().attr("condition") == "true"){
							var children = element.children();
							$.each(children,function(i){
								if ($(this).attr("value") == element.val()){
									toolParams[id.split("|")[0] + "|__current_case__"] = i.toString();	
								}
							});
						}
						toolParams[id]=element.val();
					}
					else{
						elements = $(this).find("input");	
						$.each( elements, function(i){
							if ($(this).is(':checked')){
								if($(this).parent().parent().attr("condition") == "true"){
									toolParams[id.split("|")[0] + "|__current_case__"] = i.toString();	
								}
								toolParams[id] = $(this).attr("value");
							}
						});
					}
				} 
				break;
			case "text":
					element = $(this).find("input:first");
					toolParams[id]=element.val();
				break;
			/*
			case "drill_down":
				break;
				*/
		}
		/*
		if (type == "checkbox")
		{
			if($(this).is(':checked'))
			{
				toolParams[$(this).attr('name')]=$(this).attr('trueValue');
			}
			else
			{
				toolParams[$(this).attr('name')]=$(this).attr('falseValue');
			}
		}
		else if ($(this).val() != "")
		{
			var value = $(this).val();
			toolParams[$(this).attr('name')]=value;
		}
		else if(parent[title]["id"]!="iteration")
		{
			toolParams[$(this).attr('name')]="__nv__";
		}*/
	});	
	
	//
	//
	if(parent[title]){
		if(parent[title]["id"]=="iteration")
	{
		parent[title]["parameters"] = new Array();
		if(toolParams["port"])
		{
			parent[title]["parameters"]["port"] = toolParams["port"];		
		}
		else
		{
			parent[title]["parameters"]["port"] = "-1";
		}
		if(toolParams["operator"])
		{	
			parent[title]["parameters"]["operator"] = toolParams["operator"];
		}
		else
		{
			parent[title]["parameters"]["operator"] = "-1";
		}
		if(toolParams["value"])
		{
			parent[title]["parameters"]["value"] = toolParams["value"].replace(/ /g,"__ss__");
		}
		else
		{
			parent[title]["parameters"]["value"] = "-1";
		}
		if(toolParams["feedbackInputPorts"])
		{
			var inputPorts = toolParams["feedbackInputPorts"].toString().split(",");
			parent[title]["parameters"]["inputPorts"] = new Array();
			for(inputPort in inputPorts)
			{
				parent[title]["parameters"]["inputPorts"].push(inputPorts[inputPort]);	
			}
		}
		if(toolParams["feedbackOutputPorts"])
		{
			var outputPorts = toolParams["feedbackOutputPorts"].toString().split(",");
			parent[title]["parameters"]["outputPorts"] = new Array();
			for(outputPort in outputPorts)
			{
				parent[title]["parameters"]["outputPorts"].push(outputPorts[outputPort]);
			}
		}
		if(toolParams["subworkflow"])
		{
			parent[title]["parameters"]["subworkflow"] = toolParams["subworkflow"];		
		}
		else
		{
			parent[title]["parameters"]["subworkflow"] = "-1";		
		}
	}
	else
	{
		parent[title]["parameters"] = toolParams;	
	}	
	}
	
	return toolParams;
}

function findParent(title,parentNode)
{
	//
	//return nodesArray;
	//
	
	var queue = new Array();
	enqueue(queue,nodesArray);
	
	var parents=findParents(title,queue);

	var parent = nodesArray;
	
	for (var i=1; i < parents.length; i++)
	{
		if (i == 1) 
		{
			parent = parent[parents[i]];
		}
		else{
			parent = parent['workflow'][parents[i]];
		}
	}
	
	if(parents.length == 1)
	{
		return parent;
	}
	else
	{
		if (parentNode)
		{
			return parent;				
		}
		else
		{
			return parent['workflow'];	
		}
	}
}

function enqueue(inputArray, addedElement)
{
	inputArray.push(addedElement);		
}

function dequeue(inputArray)
{
	return inputArray.splice(0,1)[0];	
}

function TraverseGraph(toolName, queue)
{
	/*
	//
	if(nodesArray[toolName] != null)
	{
		return true;
	}
	else
	{
		return false;
	}
	//
	*/
	
	var currLevel = dequeue(queue);
	
	if(currLevel['id']=='iteration')
	{
		for (l in currLevel['workflow'])
		{
			if(l != 'levels'  && currLevel['workflow'][l])
			{
				if(toolName==currLevel['workflow'][l]['name'])
				{
					return true;
				}
				else if(currLevel['workflow'][l]['id']=='iteration')
				{
					currLevel['workflow'][l]['levels'] = new Array();
					for(t in currLevel['levels'])
					{
						currLevel['workflow'][l]['levels'][t] = currLevel['levels'][t]; 
					}
					currLevel['workflow'][l]['levels'].push(currLevel['workflow'][l]['name']);
					enqueue(queue, currLevel['workflow'][l]);
				}	
			}
			
		}	
	}
	else
	{
		for (l in currLevel)
		{
			if (l != 'levels'  && currLevel[l]) 
			{
				if (toolName == currLevel[l]['name']) {
					return true;
				}
				else 
					if (currLevel[l]['id'] == 'iteration') {
						currLevel[l]['levels'] = new Array();
						for(t in currLevel['levels'])
						{
							currLevel[l]['levels'][t] = currLevel['levels'][t]; 
						}
						currLevel[l]['levels'].push(currLevel[l]['name']);
						enqueue(queue, currLevel[l]);
					}
			}
		}
	}
	
	if(queue.length==0)
	{
		return false;
	}
	else
	{
		return TraverseGraph(toolName, queue);
	}

}

function CheckIfTitleExists(title)
{
	var queue = new Array();
	enqueue(queue,nodesArray);
	
	if(TraverseGraph(title,queue))
	{
		var queue = new Array();
		enqueue(queue,nodesArray);
		var parent = findParent(title,queue)
		if(parent[title])
		{
			return true;
		}
		else
		{
			return false;
		}
	}	
	else
	{
		return false;
	}
}

function findParents(toolName, queue)
{	
	//
	//return ['#workflow'];
	//

	var currLevel = dequeue(queue);
	if(currLevel['id']=='iteration')
	{
		for (l in currLevel['workflow'])
		{
			if(l != 'levels' && currLevel['workflow'][l])
			{
				if(toolName==currLevel['workflow'][l]['name'])
				{
					return currLevel['levels'];
				}
				else if(currLevel['workflow'][l]['id']=='iteration')
				{
					currLevel['workflow'][l]['levels'] = new Array();
					for(t in currLevel['levels'])
					{
						currLevel['workflow'][l]['levels'][t] = currLevel['levels'][t]; 
					}
					currLevel['workflow'][l]['levels'].push(currLevel['workflow'][l]['name']);
					enqueue(queue, currLevel['workflow'][l]);
				}	
			}
			
		}	
	}
	else
	{
		for (l in currLevel)
		{
			if (l != 'levels'  && currLevel[l]) 
			{
				if (toolName == currLevel[l]['name']) {
					return currLevel['levels'];
				}
				else 
					if (currLevel[l]['id'] == 'iteration') {
						currLevel[l]['levels'] = new Array();
						for(t in currLevel['levels'])
						{
							currLevel[l]['levels'][t] = currLevel['levels'][t]; 
						}
						currLevel[l]['levels'].push(currLevel[l]['name']);
						enqueue(queue, currLevel[l]);
					}
			}
		}
	}
	
	if(queue.length==0)
	{
		return currLevel['levels'];
	}
	else
	{
		return findParents(toolName, queue);
	}
			
	
}

function add_new_node(id,title,data)
{

	var node = prebuild_node( 'tool', title, id );
	
	workflow.add_node( node );
	workflow.fit_canvas_to_nodes();
	canvas_manager.draw_overview();
	
	workflow.active_node.destroy();
        workflow.activate_node( node );

	node.init_field_data( data );

        var nodeElement=new Array();
	nodeElement["name"] = title;
	nodeElement["id"] = id;
	nodeElement["type"] = "tool";
	nodeElement["x"] = "200";
	nodeElement["y"] = "200";
	var parent=findParent(currIterationNode);
	parent[title] = nodeElement;



}

function add_node_for_node( id, title,params,nodeData) 
{           
		if (!params)
		{
			params = "{}";
		}
		var nodeElement=new Array();
		nodeElement["name"] = title;
		nodeElement["id"] = id;
		nodeElement["type"] = "tool";
		nodeElement["x"] = "200";
		nodeElement["y"] = "200";
		if (iterationEnable == false) 
		{
			if(id == 'iteration')
			{
				nodeElement['workflow'] = new Array();
			}
			nodesArray[title] = nodeElement;
		}
		else 
		{
			var parent=findParent(currIterationNode);
			
			parent = parent[currIterationNode];
			
			if(id=='iteration')
			{
				if(parent['workflow'])
				{
					parent['workflow'][title]=new Array();
					parent['workflow'][title]['id']='iteration';
					parent['workflow'][title]['workflow']=new Array();
					parent['workflow'][title]['name']=title;
					parent['workflow'][title]['type']="tool";
					parent['workflow'][title]['x']="200";
					parent['workflow'][title]['y']="200";
					
				}
				else
				{
					parent[title]=new Array();
					parent[title]['id']='iteration';
					parent[title]['workflow']=new Array();
					parent[title]['name']=title;
					parent[title]['type']="tool";
					parent[title]['x']="200";	
					parent[title]['y']="200";	
				}
			}
			else{
				if(parent['workflow'])
				{
					parent['workflow'][title]=nodeElement;
				}
				else
				{
					parent[title]=nodeElement;		
				}		
			}	
		}
		
        var node = prebuild_node( 'tool', title, id );
        
        workflow.add_node( node );
	if(!iterationEnable)
	{
        workflow.fit_canvas_to_nodes();
        canvas_manager.draw_overview();
	}
        workflow.activate_node( node );
	var rnode;
	if (nodeData)
	{
		rnode = node.init_field_data( nodeData );
	}
	else
	{
		if(id=="switch"||id=="iteration"||id=="merge"||id=="join"||id=="subworkflow")
		{
			$.ajax({
				url: "../bin/tavaxy/Editor.py/GetControlJSON",
				data: "controlName=" + id+ "&params=" + params+ "&owner=" + owner,	 
				type:'GET',               
			        dataType: 'json',
				async: false,
			        cache: false,
				success: function(data){
					data.form_html = data.form_html.replace(/###/g,title);
					data.name = title;
					rnode = node.init_field_data( data );
				}});
			}
		else
		{
			
			$.ajax({
				url: "../bin/tavaxy/Editor.py/GetToolJson",
				data: "toolID=" + id + "&params=" + params.replace(/ /g,"__ss__").replace("&","__and__"),	 
				type:'GET',           
			        dataType: 'json',
				async: false,
			        cache: false,
				success: function(data){
					data.form_html = data.form_html.replace(/###/g,title);
					data.name = title;
					rnode = node.init_field_data( data );
				}});
		}
	}
	return rnode;
}

// Add a new step to the workflow by tool id
function add_node_for_tool( id, title ) 
{        
if(title)
{
    title = prompt("please enter node's name", title);
if(title)
{
    	title= title.replace(/ /g,"_");
	var exists  = CheckIfTitleExists(title);
	
            if(exists)
	    {
	        alert("node with same name already exists");
			add_node_for_tool( id, title );
	    }
	    else
	    {
	        return add_node_for_node( id, title)
	    }	    
}
}
};

function add_node_for_input(type,title)
{
if(title)
{
        title.replace(/ /g,"_");
        
        var nodeElement=new Array();
        nodeElement["name"]=title;
        nodeElement["type"]="input";
	nodeElement["x"] = "200";
	nodeElement["y"] = "200";
        nodesArray[title]=nodeElement;
        
        
        node = prebuild_node( type, title );
        workflow.add_node( node );
        workflow.fit_canvas_to_nodes();
        canvas_manager.draw_overview();
        workflow.activate_node( node );     
        data={"tool_id": null, "data_inputs": [], "name": title, "form_html": "<div class=\"toolForm\">\n    <div class=\"toolFormTitle\">"+title+"<\/div>", "data_outputs": [{"name": "output", "extension": "input"}], "tooltip": null, "tool_state": "{\"name\": \"Input Dataset\"}", "type": "data_input", "annotation": ""};
        
        node.init_field_data( data );
	return node;
}
};

function add_node_for_module( type, title ) 
{
if(title)
{
    title = prompt("please enter node's name", title);
    title= title.replace(/ /g,"_");
    
    var exists = CheckIfTitleExists(title);
	
    if(exists)
	{
        alert("node with same name already exists");
		add_node_for_module( type, title );
    }
    else
    {
        add_node_for_input(type,title);
    }
}
};

function show_form_for_tool( text, node ) {
    $("#edit-attributes").hide();
	$("#right-content").show().html( text );   
    $("#right-content").find( "form" ).ajaxForm( {
        type: 'POST',
        dataType: 'json',
        success: function( data ) {
            node.update_field_data( data );
        },
        beforeSubmit: function( data ) {
            data.push( { name: 'tool_state', value: node.tool_state } );
            data.push( { name: '_', value: "true" } );
        }
    }).each( function() {
        form = this;
        $(this).find( "select[refresh_on_change='true']").change( function() {
            $(form).submit();
        });
		
        $(this).find( ".popupmenu" ).each( function() {
			var tt=this.toString();
			//alert(tt);
            var id = $(this).parents( "div.form-row" ).attr( 'id' );
			//alert("The ID: "+id);
            var b = $('<a class="popup-arrow" id="popup-arrow-for-' + id + '">&#9660;</a>');
			
            var options = {};
            $(this).find( "button" ).each( function() {
                var name = $(this).attr( 'name' );
                var value = $(this).attr( 'value' );
				//alert("The name: "+name);
			//alert("The value: "+value);
                options[ $(this).text() ] = function() {
                    $(form).append( "<input type='hidden' name='"+name+"' value='"+value+"' />" ).submit();
                }
            });
            b.insertAfter( this );
            $(this).remove();
            make_popupmenu( b, options );
        });
        
        // Implements auto-saving based on whether the inputs change. We consider
        // "changed" to be when a field is accessed and not necessarily modified
        // because of an issue where "onchange" is not triggered when activating
        // another node, or saving the workflow.
        $(this).find("input,textarea,select").each( function() {
            $(this).focus( function() {
                workflow.active_form_has_changes = true;
            });
        });
    });
    
        
}


var close_editor = function() {
    
    workflow.check_changes_in_active_form();
    if ( workflow && workflow.has_changes ) {
        do_close = function() {
            window.onbeforeunload = undefined;
            window.document.location = "/workflow"
        };
        show_modal( "Close workflow editor",
                    "There are unsaved changes to your workflow which will be lost.",
                    {
                        "Cancel" : hide_modal,
                        "Save Changes" : function() {
                            save_current_workflow( null, do_close );
                        }
                    }, {
                        "Don't Save": do_close
                    } );
    } else {
        window.document.location = "/workflow"
    }
}

var save_current_workflow = function ( eventObj, success_callback ) {
    show_modal( "Saving workflow", "progress" );
    workflow.check_changes_in_active_form();
    if (!workflow.has_changes) {
        hide_modal();
        if ( success_callback ) {
            success_callback();
        }
        return;
    }
    var savefn = function(callback) {
        $.ajax( {
            url: "/workflow/save_workflow",
            type: "POST",
            data: {
                id: "db2edea29d6dc127",
                workflow_data: function() { return JSON.stringify( workflow.to_simple() ) },
                "_": "true"
            },
            dataType: 'json',
            success: function( data ) { 
                var body = $("<div></div>").text( data.message );
                if ( data.errors ) {
                    body.addClass( "warningmark" )
                    var errlist = $( "<ul/>" );
                    $.each( data.errors, function( i, v ) {
                        $("<li></li>").text( v ).appendTo( errlist );
                    });
                    body.append( errlist );
                } else {
                    body.addClass( "donemark" );
                }
                workflow.name = data.name;
                workflow.has_changes = false;
                workflow.stored = true;
                if ( data.errors ) {
                    show_modal( "Saving workflow", body, { "Ok" : hide_modal } );
                } else {
                    if (callback) {
                        callback();
                    }
                    hide_modal();
                }
            }
        });
    }
    
    // We bind to ajaxStop because of auto-saving, since the form submission ajax
    // call needs to be completed so that the new data is saved
    if (active_ajax_call) {
        $(document).bind('ajaxStop.save_workflow', function() {
            $(document).unbind('ajaxStop.save_workflow');
            savefn();
            $(document).unbind('ajaxStop.save_workflow'); // IE7 needs it here
            active_ajax_call = false;
        });
    } else {
        savefn(success_callback);
    }
}

function HideWorkflowElement(elementName)
{
	var id = "Hide" + elementName + "Link";
	var variable = "hide" + elementName;
	eval(variable + "= !" + variable + ";");
	var variableValue = eval(variable);
	
	if (variableValue)
	{
		//$("#"+id).text("Show " + elementName);
		eval("Hide" + elementName + "();");
	}
	else
	{
		//$("#"+id).text("Hide " + elementName);
		eval("Show" + elementName + "();");
	}
}

function HideInputs()
{
	var nodes = GetNodeByType("data_input");
	HideNodes(nodes);
}
function HideStringConstants()
{
	var nodes = GetNodeByToolID("stringconstant");
	HideNodes(nodes);
}
function HideNodes(nodes)
{
	for (var i = 0; i < nodes.length; i ++)
	{	
		var id = "wf-node-step-" + nodes[i].id;
		$("#"+id).toggle();
		
		$.each(nodes[i].input_terminals, function(k, t) {
			$.each(t.connectors, function(_, c) {
				hiddenLinks[c.handle1.node.name+c.handle1.name+c.handle2.node.name+c.handle2.name] = true;
				c.redraw();
			});
        });
        $.each(nodes[i].output_terminals, function(k, t) {
			$.each(t.connectors, function(_, c) {
				hiddenLinks[c.handle1.node.name+c.handle1.name+c.handle2.node.name+c.handle2.name] = true;
				c.redraw();
			});
        });    
	}
}
function ShowInputs()
{
	var nodes = GetNodeByType("data_input");
	ShowNodes(nodes);
}
function ShowStringConstants()
{
	var nodes = GetNodeByToolID("stringconstant");
	ShowNodes(nodes);
}

function ShowNodes(nodes)
{
	for (var i = 0; i < nodes.length; i ++)
	{
		var id = "wf-node-step-" + nodes[i].id;
		var element = $("#"+id).toggle();
	
		$.each(nodes[i].input_terminals, function(k, t) {
			$.each(t.connectors, function(_, c) {
				hiddenLinks[c.handle1.node.name+c.handle1.name+c.handle2.node.name+c.handle2.name] = null;
				c.redraw();
			});
		});
		$.each(nodes[i].output_terminals, function(k, t) {
			$.each(t.connectors, function(_, c) {
				hiddenLinks[c.handle1.node.name+c.handle1.name+c.handle2.node.name+c.handle2.name] = null;
				c.redraw();
			});
		});
	}	
}

function RedrawLinks()
{
	var allNodes = workflow.nodes;
	$.each(allNodes, function(_, node) { node.redraw(); });
}

function HideDummyLinks()
{
	RedrawLinks();
}

function ShowDummyLinks()
{
	RedrawLinks();
}

function GetNodeByType(type)
{
	var nodes = [];
	$.each(workflow.nodes, function(id, item)
	{
		if (item.type == type)
		{
			nodes.push(item);
		}
	});
	return nodes;
}

function GetNodeByToolID(toolID)
{
	var nodes = [];
	$.each(workflow.nodes, function(id, item)
	{
		if (item.tool_id == toolID)
		{
			nodes.push(item);
		}
	});
	return nodes;
}

function GetNodeByName(name)
{
	var node;
	$.each(workflow.nodes, function(id, item)
	{
		if (item.name == name)
		{
			node = item;
		}
	});
	return node;
}

function layout_editor() {
	workflow.layout();
	workflow.fit_canvas_to_nodes();
	scroll_to_nodes();
	canvas_manager.draw_overview();
}
