#! /usr/bin/env python
import sys, subprocess,time,os, CommandClient as client 
import threading
import config
def log (line):
	f= open("/tmp/cluster.log",'a')
	f.write(line+'\n')
	f.flush()
	f.close()

def run(excuter,wait=True):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	if (wait):
		p.wait()
		st=p.stderr.read()
		if len(st)>0:
			f = open("/tmp/ToolServiceC.err",'a')
			f.write(st)
			f.flush()
			f.close()
			return "Error: "+ st
		else:
			return p.stdout.read()
	else:
		return p
def saveNodes(nodes):
	file=open('/root/nodesList','w')
	for node in nodes:
		file.write(node+'\n')
	file.flush()
	file.close()		
def _installNode(MasterPrivateIP,privateIP,i,s3,hostname=None ):
        log( "Installing Compute No. " + str(i)+ " ......")
        client.domain=privateIP
#	MasterPrivateID=run("ifconfig eth0 | grep 'inet addr:'").split(' ').split(":")[0]
        print client.sendNewJob(privateIP,"1","system","/root/HPCloud/installTorque.py")
	if hostname==None:
	        hostname = os.uname()[1]
	
        nodename = hostname[:-1]+str(i)
        print client.sendNewJob(privateIP,"2", "system","hostname " + nodename)
        print client.sendNewJob(privateIP,"3","system", "echo '127.0.0.1 " + nodename + "' >> /etc/hosts")
        print client.sendNewJob(privateIP,"4","system", "echo '" + MasterPrivateIP + " "+ hostname +"' >> /etc/hosts")
        print client.sendNewJob(privateIP,"5","system", "echo '$pbsserver " + hostname + "' > /var/spool/torque/mom_priv/config")
	print client.sendNewJob(privateIP,'6','system', "sudo chmod 600 /root/.passwd-s3fs;sudo bash /home/ubuntu/S3mount.bash " + s3 , ["/root/.passwd-s3fs"])
       # print client.sendNewJob("6","system","pbs_mom")
	log ("Compute No. " + str(i) + " installation ..... Done")
	return client
#_installNode ("10.228.165.171","10.58.59.117")
print "Args: " , len(sys.argv)

if (len(sys.argv)==9):
	print "Copying files....."
	print sys.argv[6] + ',' + sys.argv[7] + ',' + sys.argv[8]
	run ('cp ' + sys.argv[6] + " /root/HPCloud/cert/pk.pem")
	run ('cp ' + sys.argv[7] + " /root/HPCloud/cert/cert.pem")
	comm='cp ' + sys.argv[8] + " /root/.passwd-s3fs"
	print comm
	run (comm)

name=sys.argv[1]

MasterPrivateIP=run("ifconfig eth0 | grep 'inet addr:'").split(':')[1].split(" ")[0]
print "Server Local IP: '" + MasterPrivateIP+"'"
CoresCount=int (sys.argv[2])
s3Bucket=sys.argv[3]
sshKey=sys.argv[4]
secGroup=sys.argv[5]
nodes=[]


s = run ("cat /proc/cpuinfo | grep processor | wc -l")
s=s.strip()
print "Current No of Cores = " + s
CurrentCores=s
instanceType=run("wget -q -O - http://169.254.169.254/latest/meta-data/instance-type")
nodeCount = CoresCount-1
log ("Checking if extra nodes are needed.....")
i=1
nodes=[]
info={}
if (nodeCount>0):
	log ("Starting " + str(nodeCount) +  " more nodes......  May take up to 5 minutes")
	c="/root/HPCloud/EC2 EU1 --create " + instanceType + " " + str(nodeCount) + " " + sshKey + " " + secGroup
#	print c
	text=run(c)
	#text="""RESERVATION r-61f00317 751596604174 OurSecurity INSTANCE i-8d8324fb ami-b92710cd pending MyEUKey 0 c1.xlarge 2011-04-04T14:40:44+0000 eu-west-1a aki-119ca965 monitoring-disabled ebs paravirtual xen INSTANCE i-8b8324fd ami-b92710cd pending MyEUKey 1 c1.xlarge 2011-04-04T14:40:44+0000 eu-west-1a aki-119ca965 monitoring-disabled ebs paravirtual xen

#	print "Returned Text: " , text
	lines=text.split("INSTANCE")
	if (len(lines)==1):
		log(lines[0])
		exit (-1)
	#print "Lines: " , lines[1:]
	for line in lines[1:]:
#		print "Line: " + line
		p=line.split(" ")
#		print p[1]
		nodes.append(p[1])
	print "nodes IDs:" , nodes
	saveNodes(nodes)	
#	info={}	
	for node in nodes:
		t = run("/root/HPCloud/EC2 EU1 --details " + node)
		print t
		lines=t.split("\n")
		for line in lines:
			if ("Private IP = " in line):
				privateIP = line.split ("= ")[1].strip()
				info[node]=privateIP
				#time.sleep(30)
			
			#_installNode(MasterPrivateIP,privateIP,i)
			#nodes.append(privateIP)
				break
	print info
	time.sleep(30)
	threads=[]
	i=0
	log("Extra Machines Started.")


log("Installing main server.....")
run("/root/HPCloud/installTorque.py")
run('hostname ' +name)
run ("echo '127.0.0.1 localhost \n' > /etc/hosts")
run ("echo '" + MasterPrivateIP   + " "  +  name + "\n' >> /etc/hosts")
run ('echo ' + name + ' > /var/spool/torque/server_name')
run ('echo ' + name + ' np=' + s + ' >> /var/spool/torque/server_priv/nodes')
run ('echo $pbsserver ' + name + ' > /var/spool/torque/mom_priv/config')  
run ('pbs_server -t create')
run ("qmgr -c 'set server operators = root@" +name +"'") 
run ("qmgr -c 'set server operators += ubuntu@" + name + "'")
run ("qmgr -c 'create queue batch'")
run("qmgr -c 'set queue batch queue_type = Execution'")
run("qmgr -c 'set queue batch started = True'")
run("qmgr -c 'set queue batch enabled = True'")
run("qmgr -c 'set server default_queue = batch'")
run("qmgr -c 'set server resources_default.nodes = 1'")
run("qmgr -c 'set server scheduling = True'")
run("qmgr -c 'set server keep_completed = 86400'")
run ("qmgr -c 'set server submit_hosts = " + name + "'")
#Add Nodes here
#CoresCount = CoresCount - int (s)
 
log("Installing main server.....Done")
#nodeCount = CoresCount/8
log("Configuring Extra Machines")
if (nodeCount>0):
	for node in info.keys():
		i=i+1
#		t=threading.Thread(target=_installNode,args=[MasterPrivateIP,info[node],i], name="Thread #" + str(i))
		_installNode(MasterPrivateIP,info[node],i,s3Bucket)
		info[node]=[info[node],i]
#		t.start()
#		threads.append(t)
#	CoresCount=CoresCount-8
#	for  t in threads:
#		t.join()
	log ("Machines Configuration...Done")
	hostsfile=""
	nodesfile=""
	hostname = os.uname()[1]
	hostname=hostname[:-1]
	for node in info.keys():
		nodename = hostname+str(info[node][1])
		print "node name=" , nodename
		nodesfile+= nodename + ' np=' + str(CurrentCores)+ '\n'
	        hostsfile += info[node][0]  + " " +  nodename + '\n'
       
	run ('echo "' + nodesfile + '" >> /var/spool/torque/server_priv/nodes')
	run ('echo "'+  hostsfile + '"  >> /etc/hosts')

#Final Steps
if (nodeCount>0):
	log ('mounting S3')
	run ('sudo chown root.root /root/.passwd-s3fs')
	time.sleep(1)
	run ('sudo chmod 600 /root/.passwd-s3fs')
	time.sleep (1)
	run ('sudo bash /home/ubuntu/S3mount.bash ' + s3Bucket + ' > /tmp/s3.o 2> /tmp/s3.e')
	if config.sharedFolderSRC!="":
		if (not os.path.exists(config.sharedFolderDST)):
			log ('Copying Initial shared data...')
			run ("su ubuntu -c 'cp -r " + config.sharedFolderSRC + " " + config.sharedFolderDST + "'")
			log ('copying data ... Done')
		else:
			log ('Tavaxy Shared Folder Found....Skipping')
else:
	log ('Single Node...Escaping S3')
	if config.sharedFolderSRC!="":
		if (not os.path.exists(config.sharedFolderDST)):
			log ('linking to local data...')
			run ('ln -s ' + config.sharedFolderSRC  + ' ' + config.sharedFolderDST)
			run ('chown -R ubuntu.ubuntu' + config.sharedFolderDST)
		else:
			log('Link found......Escaping')

log("Starting daemon(s)...............")
run("qterm -t quick")
run("pbs_server &")
run('pbs_sched &')
run('pbs_mom &')

log('Starting nodes deamon..............')
if (len(info)>0):
	for node in info:
		client.domain=info[node][0]
		client.sendNewJob(info[node][0],"9","system","pbs_mom &")
print ("Completed Successfully")
log ("Completed Successfully")	
