var thereiscluster = false;
var clusterid = "dummy";
var domain = "domain";
var jobid = "jobid";
var jobrunning = true;
var createClusterSectionHidden = true;
$( function() {
	$("#cluster").hide();
	$("#startcluster").click(function(){
		var awsid = $("#awsid").val();
		var awssecretkey = $("#awssecretkey").val();
		var awskeypair = $("#awskeypair").val();
		var instances = $("#instances").val();
		var instancetype = $("#instancetype").val();
		var bootstrap = $("#bootstrap").val();
		createcluster(awsid,awssecretkey,awskeypair,instances,instancetype,bootstrap);
	});
	$("#submitjob").click(function(){
		if (thereiscluster || $("#domain").val() != ""){
			var command = $("#command").val();
			submitjob(command);
		}
		else{
			alert("A cluster must be instantiated first!");
		}
	});
	$("#createCluster").click(function(){
		if(createClusterSectionHidden){
			$("#cluster").show();
			$("#domain").attr("disabled", "disabled");
		}
		else{
			$("#cluster").hide();
			$("#domain").removeAttr("disabled");
		}
		createClusterSectionHidden = !createClusterSectionHidden;
		
	});
});

function createcluster(awsid,awssecretkey,awskeypair,instances,instancetype,bootstrap){
	$.ajax({
	  url: "bin/createcluster.py/createcluster",
	  type: "POST",
	  cache: false,
	  data: {awsid:awsid,awssecretkey:awssecretkey,awskeypair:awskeypair,instances:instances,instancetype:instancetype,bootstrap:bootstrap},
	  success: function(data){
		clusterid = data;
		$("#startcluster").attr("disabled","true");
		thereiscluster = false;
		$("#domainDiv").html("<center><img src='images/loading.gif'/><br/><p>Staring Cluster</p></center>")
		pollstatus();
	  }
	});
}

function pollstatus(){
	$.ajax({
	  url: "bin/createcluster.py/pollstatus",
	  type: "POST",
	  cache: false,
	  async: false,
	  data: {clusterid:clusterid},
	  success: function(data){
		if(data=="E"){
			thereiscluster = true;
			alert("Failed to start cluster, please try again!!!");
			resetDomainDiv();
			$("#startcluster").removeAttr("disabled");
		}
		else if(data == "C"){
			thereiscluster = true;
			getclusterdomain();
		}
	  }
	});
	if(! thereiscluster){
		setTimeout(pollstatus,5000);
	}
}

function submitjob(command){
	domain = $("#domain").val();
	owner= $("#owner").val();
	mode=$("#hadoopMode").val();
	//alert(mode+","+owner)
	$.ajax({
	  url: "bin/jobrunner.py/submitjob",
	  type: "POST",
	  cache: false,
	  data: {domain:domain,command:command,"owner":owner,"mode":mode},
	  success: function(data){
		var jobid = data;
		if (data=="Done")
		{
			alert(data)
			return
		}
		$("#job").html("<center><img src='images/loading.gif'/><br/><p>Job is being executed</p></center>")
		polljobstatus(jobid,true);
	  }
	});
}

 function polljobstatus(jobid,running){
	if (running){
		$.ajax({
		  url: "bin/jobrunner.py/pollstatus",
		  type: "POST",
		  cache: false,
		  data: {domain:domain,jobid:jobid},
		  success: function(data){
			if (data == "E" || data == "C"){
				running = false;
				$("#job").html("<p>Job is completed.</p>");
			}
		  }
		});
	}
	else{
		return false;
	}
	setTimeout(function(){polljobstatus(jobid,running)},5000);
}

function getclusterdomain(){
	$.ajax({
	  url: "bin/createcluster.py/getdomaind",
	  type: "POST",
	  cache: false,
	  data: {clusterid:clusterid},
	  success: function(data){
		if(data == "E"){
			alert("Failed to start cluster!");
			getstderr();
		}
		else{
			domain = data;
			resetDomainDiv();
			$("#domain").val(domain);
			$("#domain").attr("readonly","true");
			$("#cluster").hide();
			createClusterSectionHidden = !createClusterSectionHidden;
		}
	  }
	});
}

function getstderr(){
	$.ajax({
	  url: "bin/createcluster.py/getstderr",
	  type: "POST",
	  cache: false,
	  data: {clusterid:clusterid},
	  success: function(data){
		$("#domainDiv").html("<pre>"+data+"</pre>");
		$("#startcluster").removeAttr("disabled");
	  }
	});
}

function resetDomainDiv(){
	$("#domainDiv").html('<label>Domain:</label><input type="text" id="domain" size="100"/>');
	$("#startcluster").removeAttr("disabled");
}
