#!/usr/bin/python
import config
import socket,base64,time,sys,subprocess,ConfigParser,MySQLdb,config
import Job,Connect
domain=""
mainPath="/home/shady/MyWork2/patternsTaverna/scripts/"
logFile=""

def _select(st):
        db=connectToDB();
        db.query(st)
        r=db.store_result()
        return r.fetch_row(maxrows=0,how=1)


def _insert(st):
	
	db = connectToDB()
	cursor=db.cursor()
	cursor.execute(st)
	db.commit()
	cursor.close ()
	db.close()
def connectToDB():
	return MySQLdb.connect(host=config.usersDBhost,port=int(config.usersDBport), user=config.usersDBun, passwd=config.usersDBpwd,db=config.usersDB)
	
def sendNewJob(domain,id,owner,command,inputs=None,outputs=None):
	msg=Job.createJobMessage(id,owner,command.strip(),inputs,outputs)
	Connect.domain=domain
	res = Connect.Send(msg)
	#print "Server replied " + res
	if ("Done" in res):
		return "Done"
	if ('recieved' in res):
		id=res.split(":")[1]
	#	print "NewID: " + id
		status = Job.checkJobStatus(Connect,id,owner)
		if status=='C' or status=='E':
			if (outputs !=None):
				msg=Job.FetchOutput(id,owner,outputs)
				res = Connect.Send(msg)
				return Job.parseResponse(res)
			else:
				return "COMPLETED"

def fetchFile(id,owner,domain,outputs):
	msg = Job.FetchOutput(id,owner,outputs)
	Connect.domain=domain
	res = Connect.Send(msg)
	return Job.parseResponse(res)

def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	return p.stdout.read()

#def addNode(node, domain):
#	file=open(mainPath+'serversList','a')
#	file.write(node + " " + domain + '\n')
#	file.flush()
#	file.close()
	
def terminateNode(pkey,cert,region,id):

	run (mainPath +"startEC2 " +  pkey + " " + cert + " " + region + " --terminate " + id)
	_insert("update EC2Instances set EC2Instances.Terminated=1 where instanceID='" + id+"'")
	
def log(file,line):
	f=open(file,'a')
	f.write(line+'\n')
	f.flush()
	f.close()

def getUserAWSConf(path):
	conf = ConfigParser.RawConfigParser()
	conf.read(path)
	dict={}
	dict["pkeyfile"]=conf.get('aws','pkey')
	dict["certfile"]=conf.get('aws','cert')
	dict["accessKey"]=conf.get('aws','accessKey')
	dict["secretKey"]=conf.get('aws','secretKey')
	s3pass='/'.join(path.split('/')[:-1])+"/.passwd-s3fs"
	file=open(s3pass,'w')
	file.write(dict["accessKey"]+":"+dict["secretKey"])
	file.flush()
	file.close()
	dict["s3passwd"]=s3pass
	return dict

def createCluster(region,cores,awsfile,sshKey,group, s3,ClusterName):
		global domain,logFile
		print "In create mode....."
		
		aws=getUserAWSConf(awsfile)
		#UUID=awsfile.split('/')[-3]
		#cores=int(cores)
		#if (cores>8):
		#	c=8
		#else: c=cores
		comm= mainPath+"startEC2 " + aws["pkeyfile"] + " " + aws["certfile"] + " " + region + " --create " + cores.split('-')[0]  + " 1 " + sshKey + " " + group
		
		log(logFile,"Starting the master node this may take up to 2 minutes...running")
			
		print comm
		text = run (comm) #Start Node
		
		lines=text.split("INSTANCE")
#		print "Lines: " , lines[1:]
		nodes=[]
		for line in lines[1:]:
	#		print "Line: " + line
			p=line.split(" ")
			log(logFile,"Master Node ID: " + p[1])
			print "InstanceID = "+p[1] +"\n"
			nodes.append(p[1])
		
	#	print "nodes IDs:" , nodes	
		info={}	
		privateIP=""
		for node in nodes:
			t = run(mainPath+"startEC2 "+ aws["pkeyfile"] + " " + aws["certfile"] + " "+ region + " --details " + node)
			print t
			lines=t.split("\n")
			for line in lines:
				if "URL = " in line:
					
					domain = line.split("= ")[1].strip()[1:-1]
	#				print "Create a new cluster at : " , domain
#					addNode(node,domain)
				#if ("Private IP = " in line):
				#	privateIP = line.split ("= ")[1].strip()
	#				print "MasterNode IP '" + privateIP +"'"
			log(logFile,"Master Node started Successfully")
			from time import gmtime, strftime
			ctime = strftime("%d %m %Y %H:%M:%S +0000", gmtime())	
			#st= "Insert into EC2Instances (UUID,DNS,instanceID,StartOn,region,Cores,Name) values('" + UUID + "', '"+ domain + "','" + nodes[0]+"','"+ctime +"','" + region + "','" + str(cores) +"','" + ClusterName +"')"
			#_insert(st)
			time.sleep(30)
		
	#return st
		
		log(logFile,"Install New cluster at:" + domain + ".... May take take up to 5 mins" )
		_installCluster(cores.split("-")[1],sshKey,group,s3,aws["pkeyfile"] , aws["certfile"],aws["s3passwd"])
		time.sleep(10)
		log (logFile , "Completed Successfully")
		print "Completed Successfully"
		return domain
def terminateCluster(awsConf,region,id,domain):
	#global domain
 	#domain=sys.argv[2]
 	conf=getUserAWSConf(awsConf)
	print sendNewJob(domain,"10","system","/root/terminateCluster.py")
	terminateNode(conf['pkeyfile'],conf['certfile'],region,id,)
	return "Done"
def terminateOnFinish(domain):
        st = "select ID,UUID,Region from EC2Instances where DNS='"+domain+"'"
        rows =_select(st)
        for row in rows:
                id = str(row["ID"])
                UUID = row["UUID"]
                region = row["Region"]
                break
        awsConf=config.WebBaseStorageFolder+UUID+"/aws/aws.conf"
	conf = ConfigParser.RawConfigParser()
	conf.read(awsConf)
	pkeyfile = conf.get("aws","pkey")
	certfile = conf.get("aws","cert")
	sendNewJob(domain,"10","system","/root/terminateCluster.py")
	terminateNode(pkeyfile,certfile,region,id,)
        return "Done"



def _installCluster(cores,sshKey,group,s3,pk,cert,s3passwd):
	global domain,logFile
	cores = str(int(cores)-1)	
	if corse > 0 :
		#print sendNewJob(domain,"1","system","/root/installTorque.py")
		Command="/root/createCluster.py 'EU-Cluster5-0' '' '" + cores + "' '"+ s3 + "' '"+sshKey + "' '" +group+"' '"+   pk + "' '" + cert+"' '"+s3passwd  +"'" 
	#log(logFile,"Cluster Command:"+ Command)
		print sendNewJob(domain,"2","system",Command,[pk,cert,s3passwd])

if __name__ =="__main__":
	if sys.argv[1]=="--create":
		logFile='/'.join(sys.argv[4].split('/')[:-1])+'/tmp/cluster.log'
		domain= createCluster(sys.argv[2],sys.argv[3],sys.argv[4],sys.argv[5],sys.argv[6],sys.argv[7],sys.argv[8])
		#print sendNewJob(domain,"1",'mkalioby',"sleep 10;cat < /results/2429/input1_21 > /results/2429/res.txt",['/results/2429/input1_21'],['/results/2429/res.txt'])
		print "URL: " + domain
	elif (sys.argv[1]=="--install"):
		domain= sys.argv[2]
		privateIP=sys.argv[3]
		cores=sys.argv[4]
		awsfile=sys.argv[5]
		aws=getUserAWSConf(awsfile)
		sshKey=sys.argv[6]
		group=sys.argv[7]
		s3=sys.argv[8]
		ClusterName=sys.argv[9]
		_installCluster(str(cores),sshKey,group,s3,aws["pkeyfile"],aws["certfile"],aws["s3passwd"])
	elif (sys.argv[1]=="--run") :
		domain=sys.argv[2]
		print sendNewJob(domain,"1",'mkalioby',"sleep 10;cat < /results/2429/input1_21 > /results/2429/res.txt",['/results/2429/input1_21'],['/results/2429/res.txt'])
	elif (sys.argv[1]=="--terminate"):
		#domain,pkey,cert,region
		domain = sys.argv[5]
		print "Termination Cluster at: '" + domain+"'"
		terminateCluster(sys.argv[2],sys.argv[3],sys.argv[4],sys.argv[5])
