import random, os

def GetRandomString():
	rand = random.random()
	rand = str(rand)
	rand = rand[2:len(rand)]
	return rand

def GetProperList(input):
	if isinstance(input,list):
		if len(input) == 1:
			return GetProperList(input[0])
	return input

def CollectUnreferencedFiles(filesList):
	if isinstance(filesList,list):
		for j in range(0,len(filesList)):
			if isinstance(filesList[j],list):
				filesList[j] =  CollectUnreferencedFiles(filesList[j])
			else:
				dirName = os.path.dirname(filesList[j])
				baseName = os.path.basename(filesList[j])+"."
				unreferencedFiles = [os.path.join(dirName,f) for f in os.listdir(dirName) if f.startswith(baseName) and f[len(f)-1]!="~"]
				if len(unreferencedFiles) > 0:
					filesList[j] = sorted(unreferencedFiles)
		return filesList
	else:
		dirName = os.path.dirname(filesList)
		baseName = os.path.basename(filesList)+"."
		unreferencedFiles = [os.path.join(dirName,f) for f in os.listdir(dirName) if f.startswith(baseName) and f[len(f)-1]!="~"]
		if len(unreferencedFiles) > 0:
			return sorted(unreferencedFiles)
		else:
			return filesList
