import socket,threading,subprocess,os,base64,xml.dom.minidom
import PBS
def perpareJobStatusMessage(req,status):
        st = """<job id="%s" owner="%s" status="%s"/>""" % (req["JobID"],req["Owner"], status)
#        print st
        return st


def getOutputFiles(path):
	if ("hdfs://" in path):
		files= PBS.run("/home/hadoop/bin/hadoop dfs -ls " + path)
		if 'Cannot access' in files:
			return files
		filesList=files.split("\n")[1:-1]
		res=[]
		for file in filesList:
			res.append("hdfs://"+file.split(' ')[-1])
		return res
	return ""


def getJobStatus(req):
	global JOBS
	print 'CurrentJobs:',JOBS
	st = """<job id="%s" owner="%s" status="%s"/>""" % (req["JobID"],req["Owner"], JOBS[req["JobID"]][1])
	print st
	return st

def checkPBSstatus(id):
	list= PBS.run("qstat -f "+ id).split("\n")
	for item in list:
		if "job_state" in item:
			return item.split('=')[-1].strip()

def checkHadoopStatus(id):
	text=PBS.run("hadoop job -status " + id)
	mapCompleted=False 
	reducerCompleted=False
	text=text.split("\n")
	for line in text:
		if ("map() completion: " in line):
			 if line .split(": ")[1] == "1.0":
				 mapCompleted=True
		if ("reduce() completion: " in line): 
			if line .split(": ")[1] == "1.0":
				 reducerCompleted=True
	if mapCompleted and reducerCompleted:
		return "C"
	else:
		return "R"
