#! /usr/bin/env python
import subprocess,sys,os,threading,getIP,time
size=0

def me():
	return run("hostname").strip()
def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	if len(st)>0:
		return "ERR: " + st
	else:
		return str(p.stdout.read()).strip()
def getHostIndex():
	return int(run("hostname").split("-")[-1])
def getClusterName():
	return '-'.join(run("hostname").split("-")[:-1])

def getMyLeft():
	left="None"
	try:
		left=open('/root/EHPC/children.lst','r').read().split(',')[0]
	except:
		print "No left"
		return None
	if left=="None": 
		return None
	return getClusterName()+"-"+str(left)
	
	
def getMyRight():
	right="None"
	try:
		right=open('/root/EHPC/children.lst','r').read().strip().split(',')[1]
	except:
		print "No right"
		return None
	if right=="None": return None
	return getClusterName() + "-" + str(right)

def getParent(index):
	if index==0:
		return None
	return int(index)/2
def getMyParent():
	return getParent(getHostIndex())
def send(path,me,size,child):
	print threading.currentThread().getName()
	IP=getIP.getIP(child,True)
	print "will connect to" + child
	cmd= "/root/EHPC/disturb.py " + path + " " + me + " " + str(size)
        c="/root/EHPC/CommandClient.py --run %s 100 system '%s' '' ''"%(child,cmd)
        print c
	run(c)


if __name__=="__main__":
	src=""
	path=sys.argv[1]
	if len(sys.argv)==3:
		src=sys.argv[2]	
	else:
		src=me()
		if not os.path.exists(path):
			print "File doesn't exist on the main node...quitting"	
			exit(-1)
	src=getIP.getIP(src,True)
	myName=me()
	threads=[]
	#print getMyLeft()
	#print getMyRight()
	cmd = "sudo su ubuntu -c 'rsync -avz " +src  + ":" + path + " " + path+"'"
	print cmd
	if not os.path.exists(path):
		print "Copying Data...."
		folder=os.path.dirname(os.path.abspath(path))
		if not os.path.exists(folder):
			os.makedirs(folder)
			run('chmod 777 ' +folder)
			time.sleep(1)
		x=run (cmd)
		if "ERR:" in x:
			f=open('/tmp/100.err','w')
			f.write(x)
			f.close()
	left=getMyLeft()
	if left!=None:
	 	t=threading.Thread(target=send,args=[path,myName,size,left], name="Thread #" + str(left))
		t.start()
		threads.append(t)
		
#		cmd = "rsync -avz " + me()  + ":" + path + " " + path
#		cmd= "/home/ubuntu/disturb.py " + path + " " + me() + " " + str(size)
 #               c="/root/EHPC/CommandClient.py --run %s 100 system '%s' '' ''"%(left,cmd)
  #              print c
   #             run(c)

	right=getMyRight()
	if right!=None:
#		cmd = "rsync -avz " + me()  + ":" + path + " " + path
#		cmd= "/home/ubuntu/disturb.py " + path + " " + me() + " " + str(size)
#		c="/root/EHPC/CommandClient.py --run %s 100 system '%s' '' ''"%(right,cmd)
#		print c
#		run(c)
		x=threading.Thread(target=send,args=[path,myName,size,right], name="Thread #" + str(right))
                x.start()
		threads.append(x)
#	print cmd
	#run(cmd)
	#size=int(sys.argv[3])
	for thread in threads:
		thread.join()
	print "Disturbed"
	
	
