#! /usr/bin/env python
import sys,os,simplejson

size=0
mode=""

def getRightChild(index):
	global size
	i=int(index)+1
	right=2*i
	if (right<size):
			return right
	return None

def getLeftChild(index):
	global size
	i=int(index)+1
	left=(2*i)-1
	if left<size:
			return left
	return None

def getNextParent(d,id):
	keys=[int(key) for key in d.keys()]
	keys=sorted(keys)
	lastKey=int(keys[0])
	for key in keys[1:]:
		if key-lastKey>1:
			return lastKey+1
		lastKey=key
	return ((id+1)/2)-1	

def replaceNode(d,id,newValue):
	for key in d.keys():
		if d[key]==None: continue
		children=d[key]
                if id in children:
                	children[children.index(id)]= newValue
                        print "deleted"
			if children[0]==None and children[1]==None:
				del d[key]
	return d

def saveTree(d):
	 open('/root/EHPC/tree.json','w').write(simplejson.dumps(d))
def loadTree():
	return simplejson.loads(open('/root/EHPC/tree.json','r').read())
if __name__=="__main__":
	mode=sys.argv[1]
	for arg in sys.argv[2:]:
		if "--size" in arg:
			size=int(arg.split('=')[1])
		elif "-id" in arg:
			id=int(arg.split("=")[1])
		else:
			print "unregonized arg:", arg
	if mode=="--create":
		d={}
		for i in range(0,size):
			left = getLeftChild(i)
			right=getRightChild(i)
			if right==None and left==None: break
			d[i]=[left,right]
		saveTree(d)		

	if mode=="--del":
		newValue=None
		d=loadTree()
		print d.keys()
		if not str(id) in d.keys(): #leaf node
			print "deleting a leaf"
			d=replaceNode(d,id,None)
#			saveTree(d)
		else: #internal node
			parents=sorted(d.keys())
			parent =parents[-1]
			newParent=-1
			if d[parent][1]!=None:
				newParent=d[parent][1] 
			elif  d[parent][0]!=None:
				newParent=d[parent][0]
			else:
				newParent=parent
			#print newParent
			items=d[str(id)]
			d[newParent]=items
			d[str(id)]=None
			d=replaceNode(d,newParent,None)
			d=replaceNode(d,id,newParent)
			print d
#			print "Internal node not yet implemented"		
		saveTree(d)	
	if mode=="--add":
		d=loadTree()
		keys=[int(key) for key in d.keys()]
		parents=sorted(keys)
#                parent =parents[-1]
		added=False
		for parent in parents:
			children=d[str(parent)]
			if children == None: continue
			if children[0]==None:
				children[0]=id
				added=True
			elif children[1]==None:
				children[1]=id
				added=True
		if not added:
			newParent=getNextParent(d,id)
			d[str(newParent)]=[id,None]		
		print d
		saveTree(d)
	if mode=="--show":
		print loadTree()
