/*
 * jQuery base64 Codec
 * @author: Alex Kloss <alexthkloss@web.de>
 * @version: 0.1rc
 * @date: 21.12.2008
 */

(function($) {
	$.b64 = {
		'ct':['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'],
		'enc':function(d){
			var r = "";
			if (this.utf8) { var d = d.replace(/./g, function(x) { 
				var c = x.charCodeAt(0);
				return (String.fromCharCode(c>>8)+String.fromCharCode(c&255)); });
			}
			for (var p=0; p < d.length; p+=3) {
				r += this.ct[d.charCodeAt(p)>>2];
				r += this.ct[((d.charCodeAt(p)&3)<<4)|(!d[p+1]?0:(d.charCodeAt(p+1)>>4))];
				r += (!d[p+1]?"=":this.ct[((d.charCodeAt(p+1)&15)<<2)|(!d[p+2]?0:d.charCodeAt(p+2)>>6)]);
				r += (!d[p+2]?"=":this.ct[d.charCodeAt(p+2)&63]);
			}
			return r;
		},
		'dec':function(d){
			if (!this.dt) { this.dt = {}; 
				for (var c=0; c < 64; c++) { this.dt[this.ct[c]] = c; } }
			var r = '';
			for (var p=0; p < d.length; p+=4) {
				r += String.fromCharCode(this.dt[d[p]]<<2|this.dt[d[p+1]]>>4);
				r += (!d[p+2]||d[p+2]=='=')?'':String.fromCharCode(this.dt[d[p+1]]<<4&255|(this.dt[d[p+2]]||0)>>2);
				r += (!d[p+3]||d[p+3]=='=')?'':String.fromCharCode((this.dt[d[p+2]]||0)<<6&255|(this.dt[d[p+3]]||0));
			}
			if (this.utf8) {
				var r = r.replace(/../g, function(x) {
					return String.fromCharCode(x.charCodeAt(0)<<8|x.charCodeAt(1)); });
			}
			return r;
		}
	};
})(jQuery)
