#!/usr/bin/python
import socket,base64,time,sys,subprocess
import Job,Connect
domain=""
mainPath="/var/www/nubios/py/"
def sendNewJob(domain,id,owner,command,inputs=None,outputs=None):
	msg=Job.createJobMessage(id,owner,command.strip(),inputs,outputs)
	#print msg
	Connect.domain=domain
	print Connect.domain
	res = Connect.Send(msg)
	#print "Server replied " + res
	if ("Done" in res):
		return "Done"
	if ('recieved' in res):
		print res
		id=res.split(":")[1]
	#	print "NewID: " + id
		status = Job.checkJobStatus(Connect,id,owner)
		if status=='C' or status=='E':
			if (outputs !=None):
				msg=Job.FetchOutput(id,owner,outputs)
				res = Connect.Send(msg)
				return Job.parseResponse(res)
			else:
				return "COMPLETED"
def run(excuter):
	
	PIPE=subprocess.PIPE
	p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
	p.wait()
	st=p.stderr.read()
	return p.stdout.read()

def addNode(node, domain):
	file=open(mainPath+'serversList','a')
	file.write(node + " " + domain + '\n')
	file.flush()
	file.close()
	
def terminateNode(domain,pkey,cert,region):
	file=open(mainPath+'serversList','r')
	i=0
	l=""
	lines = file.readlines()
	for line in lines:
		if (domain in line):
			run (mainPath +"startEC2 " +  pkey + " " + cert + " " + region + " --terminate " + line.split(' ')[0])
			l=line
			break
		else: 
				i=i+1
	lines.remove(l)
	st = ''.join(lines)
	file.close()
	f=open('./serversList','w')
	f.write(st)
	f.close()
	
def createCluster(region,cores,pkey,cert):
		global domain
		print "In create mode....."
		cores=int(cores)
		if (cores>8):
			c=8
		else: c=cores
		comm= mainPath+"startEC2 " + pkey + " " + cert + " " + region + " --create " + str(c) + " 1"
	#	print comm
		text = run (comm)
		#print text
		lines=text.split("INSTANCE")
#		print "Lines: " , lines[1:]
		nodes=[]
		for line in lines[1:]:
	#		print "Line: " + line
			p=line.split(" ")
			print "InstanceID = "+p[1] +"\n"
			nodes.append(p[1])
		
	#	print "nodes IDs:" , nodes	
		info={}	
		privateIP=""
		for node in nodes:
			t = run(mainPath+"startEC2 " + pkey + " " + cert + " "+ region + " --details " + node)
			print t
			lines=t.split("\n")
			for line in lines:
				if "URL = " in line:
					
					domain = line.split("= ")[1].strip()[1:-1]
	#				print "Create a new cluster at : " , domain
					addNode(node,domain)
				if ("Private IP = " in line):
					privateIP = line.split ("= ")[1].strip()
	#				print "MasterNode IP '" + privateIP +"'"
		time.sleep(30)
		print "Install New cluster at:" , domain 
		_installCluster(privateIP,str(cores))
		time.sleep(10)
		return domain
def terminateCluster(domain,pkey,cert,region):
	#global domain
 	#domain=sys.argv[2]
	print sendNewJob(domain,"10","system","/root/terminateCluster.py")
	terminateNode(domain,pkey,cert,region)
	return "Done"

def _installCluster(privateIP,cores):
	global domain
	print sendNewJob(domain,"1","system","/root/installTorque.py")
	Command="/root/createCluster.py 'EU-Cluster5-0' '" + privateIP + "' '" + cores + "'"
	#print "Command:", Command
	print sendNewJob(domain,"2","system",Command)

if __name__ =="__main__":
	if sys.argv[1]=="--create":
		domain= createCluster(sys.argv[2],sys.argv[3],sys.argv[4],sys.argv[5])
		print sendNewJob(domain,"1",'mkalioby',"sleep 10;cat < /results/2429/input1_21 > /results/2429/res.txt",['/results/2429/input1_21'],['/results/2429/res.txt'])

	elif (sys.argv[1]=="--install"):
		domain= sys.argv[2]
		privateIP=sys.argv[3]
		cores=sys.argv[4]
		_installCluster(privateIP,str(cores))
	elif (sys.argv[1]=="--run") :
		domain=sys.argv[2]
		print sendNewJob(domain,"1",'mkalioby',"sleep 10;cat < /results/2429/input1_21 > /results/2429/res.txt",['/results/2429/input1_21'],['/results/2429/res.txt'])
	elif (sys.argv[1]=="--terminate"):
		#domain,pkey,cert,region
		domain = sys.argv[2]
		print "Termination Cluster at: '" + domain+"'"
		terminateCluster(sys.argv[2],sys.argv[3],sys.argv[4],sys.argv[5])
