#! /usr/bin/python
import os, MySQLdb,subprocess,random,simplejson
#Utils,config,
from boto.s3.connection import S3Connection
from boto.s3.connection import Location
from mod_python import util,Cookie,apache
def redirect(url,req):
	  util.redirect(req,  url)
def fbuffer(f, chunk_size=10000):
   while True:
      chunk = f.read(chunk_size)
      if not chunk: break
      yield chunk

def getCurrentZone():
	return run("wget -q -O - http://169.254.169.254/latest/meta-data/placement/availability-zone",True)

def getCurrentRegion():
        return getCurrentZone()[:-1]


def createBucket(req):
        AccessKey=req.form["accessKey"].value
        SecretKey=req.form["secretKey"].value
        Name=req.form["Name"].value
        loc=getCurrentRegion()
        conn = S3Connection(AccessKey,SecretKey)
        try:
                if (loc=="eu-west-1"):
                        bucket = conn.create_bucket(Name,location=Location.EU)
                elif loc == "us-west-1":
                        bucket = conn.create_bucket(Name,location=Location.USWest)
                elif loc == "us-west-2":
                        bucket = conn.create_bucket(Name,location=Location.USWest2)
                elif loc == "us-east-1":
                        bucket = conn.create_bucket(Name,location=Location.USEast)
                elif loc == "ap-northeast-1":
                        bucket = conn.create_bucket(Name,location=Location.APNortheast)
                elif loc == "ap-southeast-1":
                        bucket = conn.create_bucket(Name,location=Location.APSoutheast)
                elif loc == "sa-east-1":
                        bucket= conn.create_bucket(Name,location=Location.SAEast)
                else:
                        bucket = conn.create_bucket(Name)
                return getBuckets(req,Name)
	except:
		return "Choose another name"
def getStatus():
	st=""
	f=open('/tmp/cluster.log','r')
	for line in f.readlines():
		st=line+st
	f.close()
	return st
	#return f.readlines()

#Get User buckets
def getBuckets(req,selected=None):
	#return req.form.keys
	AccessKey=req.form["accessKey"].value
	SecretKey=req.form["secretKey"].value
	#return AccessKey+":"+SecretKey
	conn = S3Connection(AccessKey,SecretKey)
	buckets = str(conn.get_all_buckets())
	blist=[]
	b= buckets.split(',')
	html="<td class='subtable'>S3 Bucket:</td><td><select name='s3' id='BucketName'>"
	for bucket in b:
			st=""
			if bucket != b[-1]:	st = bucket.split(':')[1][1:-1]
			else: st = bucket.split(':')[1][1:-2]
			if (st!=selected):
				html+="<option value='" + st+"'>" + st + "</option>"
			else:
				html+="<option value='" + st+"' selected='selected'>" + st + "</option>"
	
	html+="</select>&nbsp;&nbsp;<a style='color:#074C8D;text-decoration:underline' id='newBucket' onclick='ShowNewBucketArea()' href='#'>Create New Bucket</a></td>"
	return html
	#return simplejson.dumps(blist)
	

# Run the prepared command
def run(excuter,Wait=False):

        PIPE=subprocess.PIPE
        p=subprocess.Popen(excuter,stdout=PIPE,stderr=PIPE,shell=True)
        if (Wait):
                p.wait()
                st=p.stderr.read()
                if len(st)>0:
                        #f = open("/tmp/ToolService.err",'w')
                        #f.write(st)
                        #f.flush()
                        #f.close()
                        return "Childerr:" + st
                else:
                        return str(p.stdout.read()).strip()
        else:
                return p

def _insert(st):
	
	db = connectToDB()
	cursor=db.cursor()
	cursor.execute(st)
	db.commit()
	cursor.close ()
	db.close()

def start(req):
	run ('echo "" > /tmp/cluster.log')
	pkey=req.form["pkey"]
	#return pkey
	name=req.form["name"]
	cert=req.form["cert"]
	s3=""
	nfs=""
	nfsNewVolume=""
	nfsAttachVolume=""
	nfsDevice=""
	configureS3=False
	try:
		configureS3=req.form["configureS3"]
		configureS3=True
	except:
		configureS3=False
#	return configureS3
	region="EU1" #req.form["region"]
	cores=str(int(req.form["cores"]))
	try:
		s3=req.form["s3"]
		s3MountPoint=req.form["s3MountPoint"]
		s3TempDir=req.form["s3TempDir"]
	except:
		pass
	try:
		nfs=req.form["nfsMountPoint"]
		nfsNewVolume=req.form["nfsNewVolume"]
		nfsAttachVolume=req.form["nfsAttachVol"]
		nfsDevice=req.form["nfsDevice"]
	except:
		pass
#	sshKey=req.form["sshKey"]
#	secGroup=req.form["secGroup"]
	v=getCurrentSettings()
	sshKey=v.split(":")[0]
	secGroup=v.split(":")[1]
	accessKey=req.form["accessKey"]
	secretKey=req.form["secretKey"]
	pkeyfile=""
	certfile=""
		
	#UUID=Utils.getUserUid(req)
#	path=config.WebBaseStorageFolder+UUID+"/keys/"
	path="/root/EHPC/cert/"
	try:
		os.makedirs(path)
	except Exception:
		pass
	i=0
	while i<3:
		i+=1
		fpath=""
		fileitem=""
		if (i==1):
			fileitem = pkey
			#fname = os.path.basename(fileitem.filename)
			fpath=path +"pk.pem"
			pkeyfile=fpath
			if (os.path.exists(pkeyfile)):continue
		else:
			fileitem=cert
			#fname = os.path.basename(fileitem.filename)
			fpath=path +"cert.pem"
			certfile=fpath
			if (os.path.exists(certfile)):continue
		#return fpath
		f = open(fpath, 'wb', 10000)
		# Read the file in chunks
		for chunk in fbuffer(fileitem.file):
			f.write(chunk)
		f.close()
#	f = open ('/root/.passwd-s3fs','w')
#	f.write(accessKey+":"+secretKey)
#	f.flush()
#	f.close()
#	command = "/var/www/nubios/py/CommandClient.py --create " + region + " " + cores
#	command = "/root/CommandClient.py --run 127.0.0.1 1 system '/root/installTorque.py' &"
#	return "Torque installed"
#	text=run(command)
	#return "Torque Installed"
	command = "/root/EHPC/CommandClient.py --run 127.0.0.1 '2' 'system' '/root/EHPC/EHPC-createCluster --name=%s -n=%s" %(name,cores) 
	if s3!="":
		command+=" -s3b=%s --s3-mountPoint=%s --s3-temp=%s -ak=%s -sk=%s"%(s3,s3MountPoint,s3TempDir,accessKey,secretKey)  
	if nfs!="":
		command+= " --nfs --nfs-mountPoint=%s"%nfs
		if nfsNewVolume!="":
			command+=" --nfs-newVolume=%s"%nfsNewVolume
		if nfsAttachVolume!="":
			command+=" --nfs-attachVolume=%s"%nfsAttachVolume
		if nfsDevice!="":
			command+=" --nfs-device=%s"%nfsDevice
	if configureS3:
		command+= " --configure-s3"
		if s3=="":
			command+= " -ak=%s -sk=%s"%(req.form["accessKey2"],req.form["secretKey2"])
	command+="' &"

	
	
	return command
	
	
	text=run(command)
	#return text
#	start=text.find("URL = ")
#	URL=	text[start+7:text.find(".com'",start)+4]
#	start=text.find("InstanceID = ")
#	UUID=Utils.getUserUid(req)
#	InstanceID=text[start+13:text.find("\n",start)]
#	from time import gmtime, strftime
# 	ctime = strftime("%d %m %Y %H:%M:%S +0000", gmtime())
#	st= "Insert into EC2Instances (UUID,DNS,instanceID,StartOn,region,Cores) values('" + UUID + "', '"+ URL + "','" + InstanceID+"','"+ctime +"','" + region + "'," + cores +")"
	#return st
#_insert(st)
	
	#IP=run ("/var/www/cloud/py/startEC2 " + region)
#	return  IP
	#if ("Childerr: " in  text):
	#	return "Err: " + text
	#else:
	#	import time
	#	time.sleep(20)
	redirect("../../details.html",req)  
#	return "<a href='http://" + URL + "/nubios' target='_blank'>Machine is ready you can start here</a><br/><a href='py/aws/terminate?ip=" + URL + "&region=" + region + "'>Click here</a> to terminate the machine"  

	return "Creating Cluster......"
def connectToDB():
	return MySQLdb.connect(host="localhost", user="jsf", passwd="jsf",db="nubios")

#def terminate(ip,region):
#	res=run ("/var/www/cloud/py/terminateEC2 " + region + " " + ip)
#	return res
#	if ('Done' in res):
#		return "Instance Teriminate. Thank You"

def terminateMe(req):
	run('/root/EHPC/terminateCluster.py --sucide',True)
#	id=run('wget -q -O - http://169.254.169.254/latest/meta-data/instance-id',True)
#	run ('/root/startEC2 EU1 --terminate ' + id)
	return "Done...Machine will terminate in Few Seconds"

def terminate(req,region,id,domain):
	UUID=Utils.getUserUid(req)
	path=config.WebBaseStorageFolder+UUID+"/keys/"
	pkey=path+"pkey.pem"
	cert=path+"cert.pem"
	command = "/var/www/py/CommandClient.py --terminate " + domain + " " + pkey + " " + cert + " " + region
	#return command
	
	res = run(command)
	
	#return res
	Utils._insert("delete from EC2Instances where DNS='" + domain + "'")
	return "Done" 

def MyClusters(req):
	UUID=Utils.getUserUid(req)
	rows=Utils._select("select * from EC2Instances where UUID='"+UUID+"'")
	disRows=[]
	for row in rows:
		r={"id": row["ID"]}
		cell=[row["instanceID"],"<span style='text-decoration: underline'><a href='http://"+row["DNS"]+"/nubios'>"+ row["DNS"]+"</a></span>",row["Region"],row["Cores"], row["StartOn"],"<span style='text-decoration: underline'><a href='py/aws/terminate?region=" +row["Region"] + "&id=" + row["instanceID"] +"&domain= " + row["DNS"]+"'>Terminate</a></span>"]
		r["cell"]=cell
		disRows.append(r)
	d={"page":"1","total":1,"records": str(len(rows)),"rows":disRows}
	return simplejson.dumps(d)

def getCurrentSettings():
	ssh=run("wget -q -O - http://169.254.169.254/latest/meta-data/public-keys/",True)
	#print ssh
	sshKey=ssh.split("=")[1]
	secGroup= run("wget -q -O - http://169.254.169.254/latest/meta-data/security-groups",True)
	return sshKey+":"+secGroup

